#ifndef GLOB_VAR_H
#define GLOB_VAR_H

#define PLATFORM_LINUX
//#define PLATFORM_WINDOWS


#ifdef PLATFORM_WINDOWS
    #include <process.h>
#endif

#include "specdb.h"
#include "p_types.hpp"

#ifdef PLATFORM_LINUX
#include <QString>

#define atof(a) QString(a).toDouble() ;

#endif

typedef struct
{
    int iPrediction_Frequensy_Column ;
    int iPrediction_Intensity_Column ;
    int iPrediction_LowerVibState_Column ;
    int iPrediction_UpperVibState_Column ;
    int iPrediction_RotationState_ColumnsNumber ;
    int iPrediction_LowerRotationState_Column[10] ;
    int iPrediction_UpperRotationState_Column[10] ;
    int iPrediction_LowerEnergyLevels_Column ;
    double dIntensityFactor ;
}  PREDICTION_FILE_DESCRIPTION ;



typedef struct
{
    char name[10][256];
    char params[30][80];
    int  iSymType ;

    int crit,ints,limit_nbase,v2,nj1,nj2,Iv,iatr,model;
    char mode;
    double mins,dnu ; //,alfad1,puthl,pressure1,t;
    int mol_type_reserv;
    int iUsePrediction ;
    int iUseExperienceLowLevels ;

    int nva,nvb ;

    int iNDiagolalPar, iNResonancePar ;

    double dPathLen, dPressure, dTemperature, dAlphaD, dMassOfMolecule;
    double dStatSumm, dGt, dGt1, dLow, dUp, dBr ;

    int iNDipMomParams ;

    int iCurrentRotationState, iCurrentJ ;
    int showmode ;
    int LowLevelsCombDiff ;
    int AskOverwriteMode ;
    int iSingleLinesViewNumber ;

    PREDICTION_FILE_DESCRIPTION PreditionDescroption ;

    int iMainWindowPosX, iMainWindowPosY ;
    int iMainWindowPosHeight, iMainWindowPosWidth ;
} WORKSPACE_TYPE ;


#define MOLECULE_TYPES_NUMBER   2
#define MOLECULE_TYPE_C2V       0
#define MOLECULE_TYPE_CS        1


#define HAMILTONIANS_TYPES_NUMBER       3
#define HAMILTONIANS_TYPE_WATSON        0
#define HAMILTONIANS_TYPE_PADE_BOREL    1
#define HAMILTONIANS_TYPE_GFUNCTIONS    2


#define MEASUREMENTS_TYPES_NUMBER       3
#define MEASUREMENTS_TYPE_INTENSITY     0
#define MEASUREMENTS_TYPE_ABSORBTION    1
#define MEASUREMENTS_TYPE_TRANSMITTANCE 2



#define DEF_SPECTRUM_NAME_INDEX         1
#define DEF_UPPER_STATE_PAR_INDEX       2
#define DEF_LOWER_STATE_PAR_INDEX       3
#define DEF_DIPOL_MOMENT_PAR_INDEX      4
#define DEF_UPPER_STATE_BASE_INDEX      5
#define DEF_LINES_ASSIGN_BASE_INDEX     6
#define DEF_RECOGNITION_PAR_INDEX       7
#define DEF_LOWER_STATE_NAME_INDEX      8



#define COMDIFF_NUMBER_MAX	100
#define COMDIFF_SIZE_MAX	100

#define STATE_NAME_LENGHT_MAX   30

#ifndef EXTERN

WORKSPACE_TYPE   WorkSpace ;

VIBRATION_STATE_NAME_TYPE VibStateNames[50] ;

LevelsHead_type lhead ;
LinesHead_type shead ;
Level_type level ;
Line_type sline, slinev ;


char ko[25];
/*int crit=1,ints=10,limit_nbase=2,v2,nj1,nj2,Iv,iatr,model;
char mode='s';
float mins=0.000001,dnu=0.001,alfad1,puthl,pressure1,t;
int mol_type=-1,menTM;*/

char mol_types[MOLECULE_TYPES_NUMBER][20]={"C2V","CS"};

char calcname[5][100]={"flcalc57","flcalc57"};
char fitdipname[5][100]={"fitdip5","fitdip5"};

int men, menLoad, Quit,menWS,menWL;

int CHANGED=0, ColorsCHANGED=0;

char Models[3][32]={
          "Watson","Pade-Borel","G-functions"
                    };
char MeasurementsType[3][32]={
          "intensity", "absorption", "transmitance"
                        };
char Abuff[128],key,key1,dir0[100],dir[100],bj[10],bv[10],bj1[10];


double dimom[500] ;
int number_of_levels_for_J = 0, old_number_of_levels_for_J = -1, number_of_level_for_J,  iCalcIsNesessary = 0 ;
int base_line_res[COMDIFF_NUMBER_MAX], iVariant, apr_disp_bgn = 0, iVariantBest ;

char UpperRotationStateName[STATE_NAME_LENGHT_MAX], cBaseEnergyInfo[128], LowVibName[50][STATE_NAME_LENGHT_MAX] ;

double *eexp0, *dFrequensy, *dIntensity ;

int nlinsp = 0, iLowLevelExperimetalExists = 0, iInitWorkFilesResult = 0,  iFlagCalcIsNecessary = 1 ;

FILE *fp_EnergyBank = NULL, *fp_LinesBank = NULL ;




Pvector P_x, P_mu[12], P_mu_s[12];

 int P_size = 300;
 int X_size = 7;
 int B_size = 3;

int  diffdat[COMDIFF_NUMBER_MAX][COMDIFF_SIZE_MAX], ncd, nvar ;
int  ii2[COMDIFF_SIZE_MAX*30] ;
int  ii2_sub[COMDIFF_SIZE_MAX*30] ;
double nuexp[COMDIFF_SIZE_MAX],nucalc[COMDIFF_SIZE_MAX],eclow[COMDIFF_SIZE_MAX],eexp[COMDIFF_SIZE_MAX];
double scalc[COMDIFF_SIZE_MAX];

double averageS,averageS2, Avscalc, Korell, dEnergDisp ;
double averageLogSexp, sverageLogScalc;

double averageE, full_intensity,full_found_intens, ecu ;
char ground[COMDIFF_SIZE_MAX][STATE_NAME_LENGHT_MAX];

char state_cont[20]="Vib.  J  Ka Kc";
char cDisplayLinesFields[5][50] ;
char cDisplayLinesAssignmentFields[DEF_ASSIGNMENT_FIELDS_NUMBER][128] ;
double dEestimation, dEerror, dEprobability, dAverageShift ;
int iEesimation_lines ;
int iOverwriteAllFlag = 0 ;
int iUpdateMainHeader = 0 ;
int iBestSingleLine ;
double dBestSingleLine ;

PREDICTION_FILE_DESCRIPTION PreditionDescroption ;

#else

extern WORKSPACE_TYPE   WorkSpace ;

extern VIBRATION_STATE_NAME_TYPE VibStateNames[50] ;
extern LevelsHead_type lhead ;
extern LinesHead_type shead ;
extern Level_type level ;
extern Line_type sline, slinev ;


extern char calcname[5][100] ;
extern char fitdipname[5][100] ;

extern char ko[25];
extern char mol_types[10][20];
extern char Models[3][32], MeasurementsType[3][32] ;
extern char Abuff[128],key,key1,dir0[100],dir[100],bj[10],bv[10],bj1[10];
extern char UpperRotationStateName[STATE_NAME_LENGHT_MAX], cBaseEnergyInfo[128], LowVibName[50][STATE_NAME_LENGHT_MAX] ;

extern int menTM;
extern int men, menLoad, Quit,menWS,menWL;
extern int CHANGED, ColorsCHANGED;


extern int number_of_levels_for_J, old_number_of_levels_for_J, number_of_level_for_J,iCalcIsNesessary ;
extern int base_line_res[COMDIFF_NUMBER_MAX], iVariant, apr_disp_bgn, iVariantBest ;


extern double dimom[500] ;
extern double *eexp0, *dFrequensy, *dIntensity ;

extern int nlinsp, iLowLevelExperimetalExists, iInitWorkFilesResult,  iFlagCalcIsNecessary ;

extern FILE *fp_EnergyBank, *fp_LinesBank ;




extern Pvector P_x, P_mu[12], P_mu_s[12];

extern  int P_size ;
extern  int X_size ;
extern  int B_size ;

extern int  diffdat[COMDIFF_NUMBER_MAX][COMDIFF_SIZE_MAX], ncd, nvar;
extern int  ii2[COMDIFF_SIZE_MAX*30] ;
extern int  ii2_sub[COMDIFF_SIZE_MAX*30] ;
extern double nuexp[COMDIFF_SIZE_MAX],nucalc[COMDIFF_SIZE_MAX],eclow[COMDIFF_SIZE_MAX],eexp[COMDIFF_SIZE_MAX];
extern double scalc[COMDIFF_SIZE_MAX];

extern double averageS,averageS2, Avscalc, Korell, dEnergDisp ;
extern double averageLogSexp, sverageLogScalc;

extern double averageE, full_intensity,full_found_intens, ecu ;

extern   char ground[COMDIFF_SIZE_MAX][STATE_NAME_LENGHT_MAX];
extern   char state_cont[20];
extern   char cDisplayLinesFields[5][50] ;
extern   char cDisplayLinesAssignmentFields[DEF_ASSIGNMENT_FIELDS_NUMBER][128] ;
extern double dEestimation, dEerror, dEprobability, dAverageShift ;
extern int iEesimation_lines ;
extern  int iOverwriteAllFlag ;
extern int iUpdateMainHeader ;
extern int iBestSingleLine ;
extern double dBestSingleLine ;

extern PREDICTION_FILE_DESCRIPTION PreditionDescroption ;

#endif
#endif // GLOB_VAR_H
