#include<stdio.h>
#include<errno.h>
//#include<conio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>

#define EXTERN

#include "glob_var.h"

#include "rec_proc.hpp"


#include <QString>


/*
-------------------------------------------------------------------
                                                                  
   LOAD  "itpconf.fl5"   configuration file                       
                                                                  
L-------------------------------------------------------------------
*/


void init()
{
    FILE *config;
    int i, v;


  if( ( config=fopen("itpconf.fl5","rt")) != NULL )
  {


    for(i=0;i<9;i++)
    {
          fgets(Abuff,80,config);sscanf(Abuff,"%s",WorkSpace.name[i]);
    }

    fgets(Abuff,80,config);sscanf(Abuff,"%s",ko);
    for(i=0;i<3;i++)
    {
        //printf(" ko='%s'  Meas[%d]='%s' \n",ko,i,MeasurementsType[i]);
        if( strcmp(ko,MeasurementsType[i])==0 )  WorkSpace.iatr=i;
    }

    fgets(Abuff,80,config);sscanf(Abuff,"%s",ko);

    for(i=0;i<3;i++)
    {
        //printf(" ko='%s'   Models[%d]='%s' \n",ko,i,Models[i]);
        if( strcmp(ko,Models[i])==0 )   WorkSpace.model=i;
    }

    fgets(Abuff,80,config);sscanf(Abuff,"%d", &WorkSpace.limit_nbase);

    fgets(Abuff,80,config);
    WorkSpace.iSymType = 0 ;
    for(i=0;i<10;i++)
        if( strcmp(Abuff,mol_types[i]) == 0 )  WorkSpace.iSymType = i ;

    /*fgets(Abuff,80,config);*/fscanf(config,"%d %d\n", &WorkSpace.nj1, &WorkSpace.nj2);
    fgets(Abuff,80,config); WorkSpace.mins=/*atof(Abuff)*/QString(Abuff).toDouble() ; //sscanf(Abuff,"%e", &mins);
    fgets(Abuff,80,config);sscanf(Abuff,"%d", &WorkSpace.ints);
    fgets(Abuff,80,config); WorkSpace.dnu=/*atof(Abuff)*/ QString(Abuff).toDouble() ; //sscanf(Abuff,"%f", &WorkSpace.dnu);
    fgets(Abuff,80,config); sscanf(Abuff,"%d", &WorkSpace.crit);
    fgets(Abuff,80,config); sscanf(Abuff,"%d", &v);

    //if(   WorkSpace.iatr>1 )
    {
        fgets(Abuff,80,config); WorkSpace.dPressure = /*atof(Abuff)*/QString(Abuff).toDouble(); //sscanf(Abuff,"%f", &WorkSpace.pressure1);
        fgets(Abuff,80,config); WorkSpace.dPathLen = /*atof(Abuff)*/QString(Abuff).toDouble(); //sscanf(Abuff,"%f", &WorkSpace.puthl);
        fgets(Abuff,80,config); WorkSpace.dAlphaD = /*atof(Abuff)*/QString(Abuff).toDouble(); //sscanf(Abuff,"%f", &WorkSpace.alfad1);
    };

    fclose(config);
  }
//free(rec);
}


void SaveInit()
{  FILE *config;
 int i;


   if( ( config=fopen("itpconf.fl5","wt")) == NULL )
   {
      return  ;
   };


    for(i=0;i<9;i++)
    {
        fprintf(config,"%s\n",WorkSpace.name[i]) ;
    }

    fprintf(config,"%s\n",MeasurementsType[WorkSpace.iatr]) ;

    fprintf(config,"%s\n",Models[WorkSpace.model]) ;

    fprintf(config,"%d\n", WorkSpace.limit_nbase);

    fprintf(config,"%s\n",mol_types[WorkSpace.iSymType]) ;

    fprintf(config,"%d %d\n", WorkSpace.nj1, WorkSpace.nj2);
    fprintf(config,"%.7e\n", WorkSpace.mins);
    fprintf(config,"%d\n", WorkSpace.ints);
    fprintf(config,"%.5f\n", WorkSpace.dnu);
    fprintf(config,"%d\n", WorkSpace.crit);
    fprintf(config,"%d\n", WorkSpace.Iv);

    //if(   WorkSpace.iatr>1 )
    {
        fprintf(config,"%.7e\n", WorkSpace.dPressure);
        fprintf(config,"%.7f\n", WorkSpace.dPathLen);
        fprintf(config,"%.7e\n", WorkSpace.dAlphaD);
    };

fclose(config);
}




/*
-------------------------------------------------------------------
                                                                  
   LOAD  WorkSpace                                                
                                                                  
L-------------------------------------------------------------------
*/


void LoadWorkSpace(const char *name)
{
    FILE *fp ;

    fp = fopen(name,"rb") ;
    if(fp)
    {
        fread(&WorkSpace, sizeof(WorkSpace), 1, fp ) ;
        fclose(fp) ;
    }
    else
        init() ;

}



void SaveWorkSpace(const char *name)
{
    FILE *fp ;

    fp = fopen(name,"wb") ;
    if(fp)
    {
        fwrite(&WorkSpace, sizeof(WorkSpace), 1, fp ) ;
        fclose(fp) ;
    }
}




/*
-------------------------------------------------------------------
                                                                  
   LOAD  DIPOL MOMENT PARAMETERS                                  
                                                                  
L-------------------------------------------------------------------
*/



int LoadDipolMomentParameters(char *name)
{
    FILE *ccc=fopen(name,"rt");

    if(!ccc) return -1 ;
    /*fscanf(ccc,"%d %d %d  %d  %lf %lf %lf %lf %lf %lf %lf", &WorkSpace.nva, &WorkSpace.nvb,
                                              &WorkSpace.iNDiagolalPar, &WorkSpace.iNResonancePar,
                                              &WorkSpace.dStatSumm, &WorkSpace.dGt, &WorkSpace.dGt1, &WorkSpace.dLow,
                                              &WorkSpace.dUp, &WorkSpace.dBr, &WorkSpace.dTemperature );*/

    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.nva = atoi(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.nvb = atoi(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.iNDiagolalPar = atoi(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.iNResonancePar = atoi(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.dStatSumm = atof(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.dGt = atof(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.dGt1 = atof(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.dLow = atof(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.dUp = atof(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.dBr = atof(Abuff) ;
    fscanf(ccc,"%s", Abuff ) ;  WorkSpace.dTemperature = atof(Abuff) ;

    int i ;
    //int nv=WorkSpace.nva+WorkSpace.nvb;

    if( WorkSpace.iSymType == MOLECULE_TYPE_C2V ) i=8;
    if( WorkSpace.iSymType == MOLECULE_TYPE_CS  ) i=16;
    /*for(i1=0;i1<nv;i1++)
    {
      i3 = 16*i1;
      for(i2=0;i2<16;i2++) dimom[16*nv+i2]=0.0;

        for(i2=0;i2<i;i2++)
        {
            fscanf(ccc,"%s",Abuff);
            dimom[i2+i3]=atof(Abuff);
        }

    }*/

    i = 0 ;
    while( fscanf(ccc,"%s",Abuff)>0 )
        dimom[i++]=/*atof(Abuff)*/QString(Abuff).toDouble();

    WorkSpace.iNDipMomParams = i ;

    fclose(ccc);

    return 1 ;
}


int SaveDipolMomentParameters(char *name)
{
    FILE *ccc=fopen(name,"wt");

    if(!ccc) return -1 ;
    fprintf(ccc," %d %d\n %d  %d\n  %lf %lf %lf\n %lf %lf %lf %lf\n\n", WorkSpace.nva, WorkSpace.nvb,
                                              WorkSpace.iNDiagolalPar, WorkSpace.iNResonancePar,
                                              WorkSpace.dStatSumm, WorkSpace.dGt, WorkSpace.dGt1, WorkSpace.dLow,
                                              WorkSpace.dUp, WorkSpace.dBr, WorkSpace.dTemperature);
    int i, i1 ;
    int nv=WorkSpace.nva+WorkSpace.nvb;

    if( WorkSpace.iSymType == MOLECULE_TYPE_C2V ) i=8;
    if( WorkSpace.iSymType == MOLECULE_TYPE_CS  ) i=16;

    i1 = nv * i ;
    if( WorkSpace.iNDipMomParams<i1 ) WorkSpace.iNDipMomParams = i1 ;

    i1 = 0 ;
    for(i=0; i<WorkSpace.iNDipMomParams; i++ )
    {
          fprintf(ccc,"%17.7e", dimom[i] ) ;
          i1++ ;
          if( i1 == 8 )
          {
              fprintf(ccc,"\n") ;
              i1 = 0 ;
          }
    }


    fclose(ccc);

    return 1 ;
}





/*
-----------------------------------------------------------------------------------
                                                                                  
  LEVELS DATA BANK OPEN/CLOSE                                                     
                                                                                  
L-----------------------------------------------------------------------------------
*/


int LoadInitiaDataFromEnergyBank()
{

    void UnInitEnergyBank() ;

    UnInitEnergyBank() ;

    if (  (fp_EnergyBank = fopen(WorkSpace.name[DEF_UPPER_STATE_BASE_INDEX],"rb")) !=NULL)
    {
        lhead.EndPosition = 0 ;
        fread(&lhead,sizeof(lhead),1,fp_EnergyBank);
        fread(VibStateNames,sizeof(VIBRATION_STATE_NAME_TYPE)*lhead.Nbands,1,fp_EnergyBank);

        return 1 ;
        //fclose(eee);
    }

    return -1 ;

}


int InitEnergyBankForModify()
{
    void UnInitEnergyBank() ;

    UnInitEnergyBank() ;
    if (  (fp_EnergyBank=fopen(WorkSpace.name[DEF_UPPER_STATE_BASE_INDEX],"rb+")) !=NULL) return 1 ;

    return -1 ;
}

int InitEnergyBankForReadOnly()
{
    void UnInitEnergyBank() ;

    UnInitEnergyBank() ;
    if (  (fp_EnergyBank=fopen(WorkSpace.name[DEF_UPPER_STATE_BASE_INDEX],"rb")) !=NULL) return 1 ;

    return -1 ;
}

void UnInitEnergyBank()
{
    if( fp_EnergyBank ) fclose(fp_EnergyBank) ;
    fp_EnergyBank = NULL ;
}




/*
-----------------------------------------------------------------------------------
                                                                                  
  LINES ASSIGNMENT DATA BANK OPEN/CLOSE                                           
                                                                                  
L-----------------------------------------------------------------------------------
*/


int InitLinesAssignmentBankForReadOnly()
{
    void UnInitLinesAssignmentBank() ;

    UnInitLinesAssignmentBank() ;

    //Sleep(200) ;
    if (  (fp_LinesBank = fopen(WorkSpace.name[DEF_LINES_ASSIGN_BASE_INDEX],"rb")) !=NULL)
    {
        fread(&shead,sizeof(shead),1,fp_LinesBank);

       // Sleep(200) ;
        return 1 ;
        //fclose(eee);
    }

    return -1 ;

}

int InitLinesAssignmentBankForModify()
{
    void UnInitLinesAssignmentBank() ;

    UnInitLinesAssignmentBank() ;
    //Sleep(200) ;
    if (  (fp_LinesBank = fopen(WorkSpace.name[DEF_LINES_ASSIGN_BASE_INDEX],"rb+")) !=NULL)
    {
        //Sleep(200) ;
        return 1 ;
    }

    return -1 ;
}


void UnInitLinesAssignmentBank()
{
    if( fp_LinesBank ) fclose(fp_LinesBank) ;
    fp_LinesBank = NULL ;
}



void ErrorMessage(char *str) ;

/*
-----------------------------------------------------------------------------------
                                                                                  
  LOW LEVELS EXPERIMETNAL DATA OPEN/CLOSE                                         
                                                                                  
L-----------------------------------------------------------------------------------
*/


int InitLowStateLevels()
{
    char *Abf, br[256] ;
    int i1,i2,i3 ;
    FILE *ccc ;

    if((eexp0 = (double*)(malloc (450*sizeof(double))))==NULL)
    {
        ErrorMessage("Cannot create low levels array.") ;
        exit(3);
    }
    strcpy(br,WorkSpace.name[DEF_LOWER_STATE_PAR_INDEX]) ;
    if( (Abf=strchr(br,'.'))!=NULL ) Abf[0]=0;
    sprintf(Abuff,"%s.l",br);
    if( (ccc=fopen(Abuff,"rt"))!=NULL )
    {
        for(i1=0;i1<=18;i1++)
            for(i2=-i1;i2<=i1;i2++)
        {
            br[0]=0;
            fscanf(ccc,"%s",br);
            i3=i1*i1+i1+i2;
            eexp0[i3]=/*atof(br)*/QString(br).toDouble();
                          //printf("\n  %f",eexp0[i3]);
        }
        fclose(ccc);

        //     Create temporary binary file for fask work
        /*ccc=fopen("lowexp.tmp","wb");
        fwrite(eexp0,sizeof(double),450,ccc);
        fclose(ccc);*/
    }
    else
    {
        puts("\n Can`t open ground levels file \n");
        return -1 ;
    }

    //free(eexp0) ;

    return 1 ;
}


void UnInitLowLevels()
{
   if( eexp0 ) free(eexp0) ;
   eexp0 = NULL ;
}


int AskContinue(char *str) ;


/******************************************************************************************

        SPECTRUM OPEN/CLOSE

******************************************************************************************/

int LoadSpectrum()
{
    /* *************   LOAD SPECTRUM   ***************** */
    /* */

    char bSpec[40], bStren[40] ;
    double  dFreq, dFreqPrev = 0.0, Stren, alfad, dFreqBegin, dFreqEnd ;
    FILE *ccc ;

    nlinsp = 0 ;
    ccc=fopen(WorkSpace.name[DEF_SPECTRUM_NAME_INDEX],"rt");
    if(ccc==NULL) { puts("Spectrum file not found"); return -1 ; }

    int err_num=0, iTmp, iFlagYesToAll = 0 ;
    do{
        fgets(Abuff,80,ccc);
        if (   (iTmp=sscanf(Abuff,"%s %s\n", bSpec, bStren)) > 0  )
        {
            dFreq = atof(bSpec)/*QString(bSpec).toDouble()*/;

            if( nlinsp == 0)
                dFreqBegin = dFreq ;    //  Low Frequency
            if( (iFlagYesToAll==0)&&(dFreq < dFreqPrev) )
            {
                sprintf(Abuff,"Inversion of frequency  line %d  %15.4f\nContinue?",nlinsp+1,dFreq);

                int iRet = AskContinue(Abuff) ;
                if( iRet == -1 ) exit(3) ;
                else if(iRet == 2) iFlagYesToAll = 1 ;

                err_num++;
            };
            if( dFreq != 0.0 ) dFreqPrev = dFreq;
            nlinsp++ ;
        }
    }while(feof(ccc)==0);

    /*if(err_num!=0)
    {
        exit(3) ;
    }*/

    fclose(ccc);
    dFreqEnd = dFreqPrev;                   //  Higth Frequency

    double  abko1, pressure ;

    switch(WorkSpace.iatr){
    case  MEASUREMENTS_TYPE_ABSORBTION:
                 pressure=WorkSpace.dPressure/760;
                 alfad=sqrt(WorkSpace.dTemperature/WorkSpace.dAlphaD);
                 alfad=(3.58E-7)*(dFreqBegin+dFreqEnd)*0.5*alfad;
                 abko1=log(2.0)/3.141592;
                 abko1=sqrt(abko1)/alfad;
                 break;
    case  MEASUREMENTS_TYPE_TRANSMITTANCE:
                pressure=WorkSpace.dPressure/760;
                alfad=sqrt(WorkSpace.dTemperature/WorkSpace.dAlphaD);
                alfad=(3.58E-7)*(dFreqBegin+dFreqEnd)*0.5*alfad;
                abko1=log(2.0)/3.141592;
                abko1=sqrt(abko1)/alfad;
    default : ;
    };


    dFrequensy = new double[nlinsp] ;
    dIntensity = new double[nlinsp] ;

    ccc = fopen(WorkSpace.name[DEF_SPECTRUM_NAME_INDEX],"rt");

    int i1=0;
    iFlagYesToAll = 0 ;

    do{
        fgets(Abuff,80,ccc);
        if (  (iTmp=sscanf(Abuff,"%s %s\n", bSpec, bStren)) > 0 )
        {
            dFreq=atof(bSpec)/*QString(bSpec).toDouble() */;
            // printf("%d  ",i1); puts(bStren);
            Stren=atof(bStren)/*QString(bStren).toDouble() */;

            if( (iFlagYesToAll==0)&&( (Stren==0)||(Stren>0.99999) ) )
            {
                sprintf(Abuff," Error Intensity   %d,   %.4f  %.4f\nContinue?",i1,dFreq,Stren);

                int iRet = AskContinue(Abuff) ;
                if( iRet == -1 ) exit(3) ;
                else if(iRet == 2) iFlagYesToAll = 1 ;
            }

            double st=Stren, abko;
            if(st<0.0) Stren=-st;
            switch(WorkSpace.iatr){
            case  MEASUREMENTS_TYPE_ABSORBTION:
                   Stren=1-Stren;
                   abko=Stren;
                   abko=-log(abko)/abko1/pressure/WorkSpace.dPathLen;
                   Stren=abko;
                 break;
            case  MEASUREMENTS_TYPE_TRANSMITTANCE:
                abko=Stren;
                if( (iFlagYesToAll==0)&&(Stren==0) )
                {
                    sprintf(Abuff," Error transmitance   %d,   %.4f  %.4f", i1, dFreq, Stren);

                    int iRet = AskContinue(Abuff) ;
                    if( iRet == -1 ) exit(3) ;
                    else if(iRet == 2) iFlagYesToAll = 1 ;
                }
                abko=-log(abko)/abko1/pressure/WorkSpace.dPathLen;
                Stren=abko;
            };

            if( st<0.0 ) Stren=-Stren;

            dFrequensy[i1] = dFreq ;
            dIntensity[i1] = Stren ;
            i1++ ;
        }
    }while( (feof(ccc) == 0 ) && ( i1 < nlinsp ) );

    fclose(ccc) ;

    return 1 ;
}



void UnInitSpectrum()
{
    if(dFrequensy) delete dFrequensy ;
    if(dIntensity) delete dIntensity ;
    dFrequensy = NULL ;
    dIntensity = NULL ;
}



/******************************************************************************************

        LOAD/SAVE   RECOGNITION PARAMETERS

******************************************************************************************/



void LoadRecognitionParameters()
{
    FILE *ccc ;

    int i ;
    for(i=0;i<12;i++)  P_mu[i] = new double[P_size];
    for(i=0;i<12;i++)  P_mu_s[i] = new double[P_size];
    P_x = new double[P_size];

    if( (ccc=fopen(WorkSpace.name[DEF_RECOGNITION_PAR_INDEX],"rt")) == NULL)
    {
       int i2 ;
       for(i2=0;i2<12;i2++) reset( P_mu[i2]  );
       for(i2=0;i2<12;i2++) reset( P_mu_s[i2]);
       WorkSpace.showmode=0;
    }
    else
    {
       for(i=0;i<12;i++) Pread(P_mu[i],ccc);
       for(i=0;i<12;i++) Pread(P_mu_s[i],ccc);
       //fscanf(ccc,"%d",&showmode);
       fclose(ccc);
    }

}


void SaveRecognitionParameters()
{
    FILE *ccc ;

    int i ;
    ccc=fopen(WorkSpace.name[DEF_RECOGNITION_PAR_INDEX],"wt");
    if(ccc==NULL) return ;

    for(i=0;i<12;i++) Pwrite(P_mu[i],ccc);
    for(i=0;i<12;i++) Pwrite(P_mu_s[i],ccc);
    fclose(ccc);


    for(i=0;i<12;i++)  delete P_mu[i];
    for(i=0;i<12;i++)  delete P_mu_s[i];
    delete P_x ;

}


/******************************************************************************************

        ALL FILES OPEN/CLOSE

******************************************************************************************/


int InitAllWorkDataFiles()
{
    iInitWorkFilesResult = 0 ;

    LoadRecognitionParameters() ;

    if( LoadSpectrum()!= 1 )  return -1 ;

    if( WorkSpace.iUseExperienceLowLevels == 1 )
    {
        iLowLevelExperimetalExists = InitLowStateLevels() ;

        if( iLowLevelExperimetalExists != 1 )
        {
            UnInitLowLevels() ;
        }
    }

    if( LoadInitiaDataFromEnergyBank() != 1 )
    {
        UnInitSpectrum() ;
        UnInitLowLevels() ;
        ErrorMessage("Energy levels data bank not found.") ;
        return -1 ;
    }

    if( InitLinesAssignmentBankForReadOnly() != 1 )
    {

        UnInitSpectrum() ;
        UnInitLowLevels() ;
        UnInitEnergyBank() ;
        ErrorMessage("Assignment data bank not found.") ;
        return -1 ;
    }


    iInitWorkFilesResult = 1 ;
    iFlagCalcIsNecessary = 1 ;

    return 1 ;
}




void CloseAllFiles()
{
    UnInitSpectrum() ;
    UnInitLowLevels() ;
    UnInitEnergyBank() ;
    UnInitLinesAssignmentBank() ;

    SaveRecognitionParameters() ;
}




void InitPredictionFileDescription()
{
    WorkSpace.PreditionDescroption.iPrediction_Frequensy_Column = 0 ;
    WorkSpace.PreditionDescroption.iPrediction_Intensity_Column = 1 ;
    WorkSpace.PreditionDescroption.iPrediction_UpperVibState_Column = 3 ;
    WorkSpace.PreditionDescroption.iPrediction_LowerVibState_Column = 10 ;
    WorkSpace.PreditionDescroption.iPrediction_RotationState_ColumnsNumber = 3 ;
    WorkSpace.PreditionDescroption.iPrediction_UpperRotationState_Column[0] = 4 ;
    WorkSpace.PreditionDescroption.iPrediction_UpperRotationState_Column[1] = 5 ;
    WorkSpace.PreditionDescroption.iPrediction_UpperRotationState_Column[2] = 6 ;
    WorkSpace.PreditionDescroption.iPrediction_LowerRotationState_Column[0] = 7 ;
    WorkSpace.PreditionDescroption.iPrediction_LowerRotationState_Column[1] = 8 ;
    WorkSpace.PreditionDescroption.iPrediction_LowerRotationState_Column[2] = 9 ;
}
