#include <math.h>
#include "mainwindow.h"
#include "ui_mainwindow.h"


#include <QString>
#include <QFile>
#include <QFileDialog>
#include <QStringList>
#include <QInputDialog>
#include <QStandardItem>
#include <QTimer>
#include <QScrollBar>
#include <QMessageBox>
#include <QProcess>


#include "dialog_parameters.h"
#include "dialog_about.h"
//#include "dialog_manual.h"

#include "glob_var.h"
#include "fldl54.h"



QString qstringCurrentFileName, fileNamePath ;

static int iTimerCount = 0 ;
char cBuffer[256] ;

void init() ;
void SaveInit() ;
void LoadWorkSpace(const char *name) ;
void SaveWorkSpace(const char *name) ;
int InitAllWorkDataFiles() ;
void CloseAllFiles() ;
int getJfromN( int iCurrentRotationState ) ;

int ReadBankLevel(int V,int number_of_level_abs) ;
void InitPredictionFileDescription() ;


static QStandardItem *table_item[50] ;

static int iShowMode = 0 ;

QProcess *process_Manual = NULL ;



MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    InitPredictionFileDescription() ;

    //DialogParameters = new Dialog_Parameters(this) ;
    //this->connect( &DialogParameters, DialogParameters.updateMenus, initMenuValues ) ;
    //init() ;
    WorkSpace.iMainWindowPosX = this->pos().x() ;
    WorkSpace.iMainWindowPosY = this->pos().y() ;
    WorkSpace.iMainWindowPosHeight = this->height() ;
    WorkSpace.iMainWindowPosWidth = this->width() ;

    LoadWorkSpace("task.wsp") ;

    this->move( WorkSpace.iMainWindowPosX, WorkSpace.iMainWindowPosY) ;
    this->resize(WorkSpace.iMainWindowPosWidth, WorkSpace.iMainWindowPosHeight);
    WorkSpace.iMainWindowPosY = this->pos().y() ;
    WorkSpace.iMainWindowPosHeight = this->height() ;
    WorkSpace.iMainWindowPosWidth = this->width() ;

    //LoadInitiaDataFromEnergyBank() ;

    iTablesAreCleared = 1 ;
    InitAllWorkDataFiles() ;
    initMenuValues() ;
    table_model = NULL ;
    table_model_assignment = NULL ;

    connect(&timer, SIGNAL(timeout()), this, SLOT( TimerProcessingSlot())  ) ;

    timer.start(200);
    EnableDatabaseButtons(false) ;
}



MainWindow::~MainWindow()
{
    WorkSpace.iMainWindowPosX = this->pos().x() ;
    WorkSpace.iMainWindowPosY = this->pos().y() ;
    WorkSpace.iMainWindowPosHeight = this->height() ;
    WorkSpace.iMainWindowPosWidth = this->width() ;
    if( !process_Manual ) delete process_Manual ;

    SaveWorkSpace("task.wsp") ;
    CloseAllFiles() ;
    if( table_model ) delete table_model ;
    if( table_model_assignment ) delete table_model_assignment ;
    SaveInit() ;
    delete ui;
}




void MainWindow::ClearTables()
{
    if( iTablesAreCleared == 1 ) return ;

    ui->lineEdit_EstimatedEnergy->clear() ;
    ui->lineEdit_ModelEnergy->clear() ;

    /*if( table_model ) delete table_model ;
    table_model = new QStandardItemModel(3,1) ;
    ui->tableViewCombDiffLines->setModel( table_model );
    ui->tableViewCombDiffLines->setColumnWidth(0,ui->tableViewCombDiffLines->width()) ;

    if( table_model_assignment ) delete table_model_assignment ;
    table_model_assignment = new QStandardItemModel(3,DEF_ASSIGNMENT_FIELDS_NUMBER) ;
    ui->tableView_Assignment->setModel( table_model_assignment ) ;
    int line_num = 0 ;
    for(line_num = 0; line_num<3; line_num++)
    {
        table_item[0] = new QStandardItem() ;
        table_item[0]->setEditable(false) ;
        table_item[1] = new QStandardItem() ;
        table_item[1]->setEditable(false) ;
        table_item[2] = new QStandardItem() ;
        table_item[2]->setEditable(false) ;
        table_item[3] = new QStandardItem() ;
        table_item[3]->setEditable(false) ;
        table_item[4] = new QStandardItem() ;
        table_item[4]->setEditable(false) ;
        table_item[5] = new QStandardItem() ;
        table_item[5]->setEditable(false) ;

        //table_item[0]->setCheckable(true) ;

        table_model->setItem( line_num, 0, table_item[0] ) ;

        table_model_assignment->setItem( line_num, 0, table_item[1] ) ;
        table_model_assignment->setItem( line_num, 1, table_item[2] ) ;
        table_model_assignment->setItem( line_num, 2, table_item[3] ) ;
        table_model_assignment->setItem( line_num, 3, table_item[4] ) ;
        table_model_assignment->setItem( line_num, 4, table_item[5] ) ;

        //char Abuff[10] ;
        Abuff[0] = 0 ;
        table_model->item(line_num,0)->setText(Abuff) ;

        table_model_assignment->item(line_num,0)->setText(Abuff) ;
        table_model_assignment->item(line_num,1)->setText(Abuff) ;
        table_model_assignment->item(line_num,2)->setText(Abuff) ;
        table_model_assignment->item(line_num,3)->setText(Abuff) ;
        table_model_assignment->item(line_num,4)->setText(Abuff) ;
    }*/

    ClearVariantLinesDisplay() ;

    iTablesAreCleared = 1 ;
}


void MainWindow::EnableDatabaseButtons( bool flag )
{
    ui->actionWriteAssignment_1->setEnabled( flag ) ;
    ui->actionWriteAssignment_2->setEnabled( flag ) ;
    ui->actionWriteAssignment_3->setEnabled( flag ) ;
    ui->actionWriteAssignment_4->setEnabled( flag ) ;
    ui->actionWriteAssignment_5->setEnabled( flag ) ;
    ui->action_WriteAssignment_Y->setEnabled( flag ) ;
    ui->actionDelete_assignment_1->setEnabled( flag ) ;
    ui->actionDelete_assignment_2->setEnabled( flag ) ;
    ui->actionDelete_assignment_3->setEnabled( flag ) ;
    ui->actionDelete_assignment_4->setEnabled( flag ) ;
    ui->actionDelete_assignment_5->setEnabled( flag ) ;
    ui->actionDelete_assignment_Y->setEnabled( flag ) ;
    ui->actionClear_energy->setEnabled( flag ) ;
    ui->actionSave_energy->setEnabled( flag ) ;
    ui->action_Teach->setEnabled( flag ) ;
    ui->action_RemoveAllAssignmentForLevel->setEnabled( flag ) ;

    if( flag == false )
    {
        ui->action_PgUp->setEnabled(false) ;
        ui->action_PgDn->setEnabled(false) ;
        ui->pushButton_NextCombDiffVariant->setEnabled(false);
        ui->pushButton_PrevCombDiffVariant->setEnabled(false);
    }

}




void MainWindow::on_action_Load_config_triggered()
{
     QString Filters = QString("Workspace *.wsp (*.wsp)") ;
     QString FilterRet ;

     QFileDialog myFileDialog(this, tr("Open File"),
                              QString()) ;

     if( !fileNamePath.isEmpty() )
     {
         myFileDialog.setDirectory(QDir(fileNamePath));
     }


     QString fileName = myFileDialog.getOpenFileName (this, tr("Open File"), QString(""), Filters, &FilterRet, 0  ) ;

     if( !fileName.isEmpty() )
     {
         fileNamePath = fileName.left(fileName.lastIndexOf('/') ) ;

         qstringCurrentFileName = fileName ;
         LoadWorkSpace(fileName.toAscii().constData()) ;
         InitAllWorkDataFiles() ;
         initMenuValues() ;
         iUpdateMainHeader = 1 ;
     }
}


/*
------------------------------------------------------------------
                                                                  
          initMenuValues()                                        
                                                                  
------------------------------------------------------------------
*/
void MainWindow::initMenuValues()
{

    sprintf(cBuffer, "Minimal intensity:  %.3e", WorkSpace.mins) ;
    ui->actionMinimal_intensity->setText(cBuffer);

    sprintf(cBuffer, "Combination presision:  %.5f", WorkSpace.dnu) ;
    ui->actionCombination_presision->setText(cBuffer);

    sprintf(cBuffer, "Interval of search:  :  %d", WorkSpace.ints) ;
    ui->actionLines_number_of_interval->setText(cBuffer);

    sprintf(cBuffer, "Base line limit:  %d", WorkSpace.limit_nbase) ;
    ui->actionBase_line_limit->setText(cBuffer);
    
    sprintf(cBuffer, "Minimal lines number in combination :  %d", WorkSpace.crit) ;
    ui->action_Minimal_lines_number_in_combination->setText(cBuffer);
   

    ui->spinBox_J->setValue( getJfromN( WorkSpace.iCurrentRotationState ) ) ;

    ui->spinBox_Vib->setValue( WorkSpace.Iv ) ;
    ui->lineEdit_VState->setText( VibStateNames[WorkSpace.Iv-1] ) ;

    getupperstate( WorkSpace.iCurrentRotationState, UpperRotationStateName ) ;
    ui->lineEdit_RState->setText(UpperRotationStateName) ;

}


void MainWindow::on_actionMinimal_intensity_triggered()
{
    QInputDialog InpD;
    bool ok ;
    double dRet ;

    QString str ;

    dRet = InpD.getText(  this, QString("Input value"), QString("Minimal intensity"), QLineEdit::Normal, str.sprintf("%.3e",WorkSpace.mins), &ok ).toDouble() ;
    if(ok)
    {
        WorkSpace.mins = dRet ;
        sprintf(cBuffer, "Minimal intensity:  %.3e", WorkSpace.mins) ;
        ui->actionMinimal_intensity->setText(cBuffer);
    }
}

void MainWindow::on_actionCombination_presision_triggered()
{
    QInputDialog InpD;
    bool ok ;
    double dRet ;

    QString str ;

    dRet = InpD.getText(  this, QString("Input value"), QString("Combination rule presision"), QLineEdit::Normal, str.sprintf("%.5f",WorkSpace.dnu), &ok ).toDouble() ;
    if(ok)
    {
        WorkSpace.dnu = dRet ;
        sprintf(cBuffer, "Combination presision:  %.5f", WorkSpace.dnu) ;
        ui->actionCombination_presision->setText(cBuffer);
    }
}

void MainWindow::on_actionLines_number_of_interval_triggered()
{
    QInputDialog InpD;
    bool ok ;
    int iRet ;

    iRet = InpD.getInt(  this, QString("Input value"), QString("Interval of search, presented in lines"), WorkSpace.ints, 1, 10000, 1, &ok ) ;
    if(ok)
    {
        WorkSpace.ints = iRet ;
        sprintf(cBuffer, "Interval of search:  %d", WorkSpace.ints) ;
        ui->actionLines_number_of_interval->setText(cBuffer);
    }
}

void MainWindow::on_actionBase_line_limit_triggered()
{
    QInputDialog InpD;
    bool ok ;
    int iRet ;

    iRet = InpD.getInt(  this, QString("Input value"), QString("Base line limit"), WorkSpace.limit_nbase, 1, 100, 1, &ok ) ;
    if(ok)
    {
        WorkSpace.limit_nbase = iRet ;
        sprintf(cBuffer, "Base line limit:  %d", WorkSpace.limit_nbase) ;
        ui->actionBase_line_limit->setText(cBuffer);
    }
}

void MainWindow::on_actionExit_triggered()
{
    this->close() ;
}

void MainWindow::on_actionFiles_and_parameters_triggered()
{
    //CloseAllFiles() ;
    iFlagCalcIsNecessary = 1 ;
    EnableDatabaseButtons(false) ;
    ui->lineEdit_DataBankEnergy->setText(QString(""));

    DialogParameters.InitDialog() ;
    DialogParameters.setModal(true) ;
    DialogParameters.show() ;
    //initMenuValues() ;

}


void MainWindow::on_labelVibrartionstate_linkActivated(QString link)
{
}

void MainWindow::on_spinBox_J_valueChanged(int )
{
    int j = ui->spinBox_J->value() ;

    ClearTables() ;
    EnableDatabaseButtons( false ) ;

    if( j>WorkSpace.iCurrentJ ) WorkSpace.iCurrentRotationState = getStartNfromJ( j ) ;
    if( j<WorkSpace.iCurrentJ ) WorkSpace.iCurrentRotationState = getEndNfromJ( j ) ;

    WorkSpace.iCurrentJ = j ;

    getupperstate( WorkSpace.iCurrentRotationState, UpperRotationStateName ) ;
    ui->lineEdit_RState->setText(UpperRotationStateName) ;

    ReadBankLevel( WorkSpace.Iv-1,WorkSpace.iCurrentRotationState) ;
    ui->lineEdit_DataBankEnergy->setText( cBaseEnergyInfo ) ;
    iCalcIsNesessary = 1 ;
}

void MainWindow::on_pushButton_RPlus_clicked()
{
    int j_old = ui->spinBox_J->value() ;

    ClearTables() ;
    EnableDatabaseButtons( false ) ;

    WorkSpace.iCurrentRotationState++ ;
    getupperstate( WorkSpace.iCurrentRotationState, UpperRotationStateName ) ;
    ui->lineEdit_RState->setText(UpperRotationStateName) ;

    int j = getJfromN( WorkSpace.iCurrentRotationState ) ;
    WorkSpace.iCurrentJ = j ;
    if( j != j_old )
    {
        ui->spinBox_J->setValue( j );
        iFlagCalcIsNecessary = 1 ;
    }

    ReadBankLevel( WorkSpace.Iv-1,WorkSpace.iCurrentRotationState) ;
    ui->lineEdit_DataBankEnergy->setText( cBaseEnergyInfo ) ;

}


void MainWindow::on_pushButton_RMinus_clicked()
{
    int j_old = ui->spinBox_J->value() ;

    ClearTables() ;
    EnableDatabaseButtons( false ) ;

    if( WorkSpace.iCurrentRotationState == 0 ) return ;
    WorkSpace.iCurrentRotationState-- ;

    getupperstate( WorkSpace.iCurrentRotationState, UpperRotationStateName ) ;
    ui->lineEdit_RState->setText(UpperRotationStateName) ;

    int j = getJfromN( WorkSpace.iCurrentRotationState ) ;
    WorkSpace.iCurrentJ = j ;
    if( j != j_old )
    {
        ui->spinBox_J->setValue( j );
        iFlagCalcIsNecessary = 1 ;
    }

    ReadBankLevel( WorkSpace.Iv-1,WorkSpace.iCurrentRotationState) ;
    ui->lineEdit_DataBankEnergy->setText( cBaseEnergyInfo ) ;

}


void MainWindow::on_spinBox_Vib_valueChanged(int )
{
    int v = ui->spinBox_Vib->value() ;

    if( v > (WorkSpace.nva+WorkSpace.nvb) ) v = WorkSpace.nva+WorkSpace.nvb ;

    WorkSpace.Iv = v ;
    ui->spinBox_Vib->setValue( v ) ;

    ui->lineEdit_VState->setText( VibStateNames[v-1] ) ;

    ReadBankLevel( WorkSpace.Iv-1,WorkSpace.iCurrentRotationState) ;
    ui->lineEdit_DataBankEnergy->setText( cBaseEnergyInfo ) ;

    iFlagCalcIsNecessary = 1 ;
    ClearTables() ;
    EnableDatabaseButtons( false ) ;
}








void MainWindow::on_toolButton_SearchCombDiff_clicked()
{

    int search_lines(int search_mode, double E) ;
    int calc() ;
    int DetectBestVariant() ;
    int InitEnergyBankForModify() ;
    int  PredictionFileProcessing( char *RotationStateName) ;

    //strcpy( UpperRotationStateName,ui->lineEdit_RState->text().toAscii().data()) ;
    //ui->tableViewCombDiffLines->setEnabled(true);
    //ui->tableView_Assignment->setEnabled(true);
    iTablesAreCleared = 0 ;

    if( WorkSpace.iUsePrediction == 1 )
    {
        PredictionFileProcessing( ui->lineEdit_RState->text().toAscii().data() ) ;
    }
    else
    {
        calc() ;
    }

    iShowMode = 1 ;

    //InitEnergyBankForModify() ;


    search_lines(0, 0.0) ;

    sprintf(Abuff,"%.6f", ecu) ;
    ui->lineEdit_ModelEnergy->setText(Abuff);

    int i3 ;

    if( (ncd>0)&&(nvar>0) )
    {
        EnableDatabaseButtons(true) ;
        ui->action_PgUp->setEnabled(true) ;
        ui->action_PgDn->setEnabled(true) ;
        ui->pushButton_NextCombDiffVariant->setEnabled(true);
        ui->pushButton_PrevCombDiffVariant->setEnabled(true);

        iVariantBest = DetectBestVariant() ;

        iVariant = iVariantBest ;


        //i3=ChooseVar();   /*nline=0;*/
        sprintf(Abuff,"Var.%2d (from %2d),base %2d, best %2d", iVariant+1, nvar, base_line_res[iVariant],iVariantBest+1) ;
        ui->label_Variant->setText(Abuff);

        if( table_model ) delete table_model ;
        table_model = new QStandardItemModel(ncd,1) ;
        ui->tableViewCombDiffLines->setModel( table_model );
        ui->tableViewCombDiffLines->setColumnWidth(0,ui->tableViewCombDiffLines->width()) ;

        if( table_model_assignment ) delete table_model_assignment ;
        table_model_assignment = new QStandardItemModel(ncd,DEF_ASSIGNMENT_FIELDS_NUMBER) ;
        ui->tableView_Assignment->setModel( table_model_assignment ) ;
        //ui->tableView_Assignment->setSelectionMode(QAbstractItemView::NoSelection);
        ui->tableView_Assignment->setColumnWidth(0,ui->tableView_Assignment->width()/2) ;
        ui->tableView_Assignment->setColumnWidth(1,ui->tableView_Assignment->width()/2) ;
        ui->tableView_Assignment->setColumnWidth(2,ui->tableView_Assignment->width()/2) ;
        ui->tableView_Assignment->setColumnWidth(3,ui->tableView_Assignment->width()/2) ;
        ui->tableView_Assignment->setColumnWidth(4,ui->tableView_Assignment->width()/2) ;

        int line_num ;
        for(line_num = 0 ; line_num<ncd ; line_num++)
        {
            table_item[0] = new QStandardItem() ;
            table_item[0]->setEditable(false) ;
            table_item[1] = new QStandardItem() ;
            table_item[1]->setEditable(false) ;
            table_item[2] = new QStandardItem() ;
            table_item[2]->setEditable(false) ;
            table_item[3] = new QStandardItem() ;
            table_item[3]->setEditable(false) ;
            table_item[4] = new QStandardItem() ;
            table_item[4]->setEditable(false) ;
            table_item[5] = new QStandardItem() ;
            table_item[5]->setEditable(false) ;

            //table_item[0]->setCheckable(true) ;

            table_model->setItem( line_num, 0, table_item[0] ) ;

            table_model_assignment->setItem( line_num, 0, table_item[1] ) ;
            table_model_assignment->setItem( line_num, 1, table_item[2] ) ;
            table_model_assignment->setItem( line_num, 2, table_item[3] ) ;
            table_model_assignment->setItem( line_num, 3, table_item[4] ) ;
            table_model_assignment->setItem( line_num, 4, table_item[5] ) ;
        }

        FillVariantLinesDisplay( iVariant ) ;

        //ui->tableViewCombDiffLines->vsetVerticalScrollBar(ui->tableView_Assignment->verticalScrollBar()) ;
        //ui->tableViewCombDiffLines->verticalScrollBar()

        //ui->tableViewCombDiffLines->connect(ui->tableView_Assignment,ui->tableView_Assignment->contentsMargins(),ui->tableViewCombDiffLines->contentsMargins()) ;
        if(i3==0)
        {
            //i1=shl();
        }

     } /* found */
     else
       if(ncd>0)
     {
           EnableDatabaseButtons(false) ;
     }

    /*if( (command=='s')||(command=='S') )
    {
        if( ncd==0 ) puts("\n the number of lines in com dif =0");
         else
        {
            do{
                    i1=shl();
            }while(i1!=0);
        }
    }*/

}








void MainWindow::FillVariantLinesDisplay( int iVariant )
{
    int line_num ;
    void showSinglline(int icombline,int ispecline, char *Abuff) ;
    int shvarline(int line_num,int variant) ;
    void shApline(int iline,int icomb_index) ;
    void MarkCombinationRecognition(int ivar) ;
    void EstimateEnergy() ;

    //ui->tableWidgetCombDiffLines->setRowCount(ncd) ;
    //ui->tableWidgetCombDiffLines->setColumnCount(1) ;

    MarkCombinationRecognition(iVariant) ;

    for(line_num = 0 ;  line_num<ncd ; line_num++)
    {
        shvarline(line_num, iVariant) ;
        table_model->item(line_num,0)->setText(Abuff) ;

        shApline( diffdat[iVariant][line_num], line_num) ;
        table_model_assignment->item(line_num,0)->setText(cDisplayLinesAssignmentFields[0]) ;
        table_model_assignment->item(line_num,1)->setText(cDisplayLinesAssignmentFields[1]) ;
        table_model_assignment->item(line_num,2)->setText(cDisplayLinesAssignmentFields[2]) ;
        table_model_assignment->item(line_num,3)->setText(cDisplayLinesAssignmentFields[3]) ;
        table_model_assignment->item(line_num,4)->setText(cDisplayLinesAssignmentFields[4]) ;

        if(diffdat[iVariant][line_num]==-1)
            table_model->item(line_num,0)->setCheckable(false);
        else
            table_model->item(line_num,0)->setCheckable(true);

        if(  ii2[line_num] == 1 )
        {
            table_model->item(line_num,0)->setCheckState(Qt::Checked) ;
            table_model->item(line_num,0)->setForeground(Qt::red);
        }
        else
        {
            table_model->item(line_num,0)->setCheckState(Qt::Unchecked) ;
            table_model->item(line_num,0)->setForeground(Qt::white);
        }
    }

    ui->tableViewCombDiffLines->selectRow(0) ;
    EstimateEnergy() ;
    ui->lineEdit_EstimatedEnergy->setText(Abuff);

}


void MainWindow::ClearVariantLinesDisplay()
{
    int line_num ;
    void showSinglline(int icombline,int ispecline, char *Abuff) ;
    int shvarline(int line_num,int variant) ;
    void shApline(int iline,int icomb_index) ;
    void MarkCombinationRecognition(int ivar) ;
    void EstimateEnergy() ;

    //ui->tableWidgetCombDiffLines->setRowCount(ncd) ;
    //ui->tableWidgetCombDiffLines->setColumnCount(1) ;

    MarkCombinationRecognition(iVariant) ;

    int iNlines ;
    if( iShowMode == 1 ) iNlines = ncd ;
    else
        if( iShowMode == 2 ) iNlines = ncd * iSingleLinesViewNumber ;

    for(line_num = 0 ;  line_num<iNlines ; line_num++)
    {
        shvarline(line_num, iVariant) ;
        table_model->item(line_num,0)->setText("") ;

        shApline( diffdat[iVariant][line_num], line_num) ;
        table_model_assignment->item(line_num,0)->setText("") ;
        table_model_assignment->item(line_num,1)->setText("") ;
        table_model_assignment->item(line_num,2)->setText("") ;
        table_model_assignment->item(line_num,3)->setText("") ;
        table_model_assignment->item(line_num,4)->setText("") ;

        table_model->item(line_num,0)->setCheckState(Qt::Unchecked) ;
        table_model->item(line_num,0)->setForeground(Qt::white);

    }
}



void MainWindow::on_toolButton_PrevCombDiffVariant_clicked()
{
    if( iVariant>0 ) iVariant-- ;

    sprintf(Abuff,"Var.%2d (from %2d),base %2d, best %2d", iVariant+1, nvar, base_line_res[iVariant],iVariantBest+1) ;
    ui->label_Variant->setText(Abuff);

    FillVariantLinesDisplay( iVariant ) ;
}

void MainWindow::on_toolButton_NextCombDiffVariant_clicked()
{
    if( iVariant<nvar-1 ) iVariant++ ;

    sprintf(Abuff,"Var.%2d (from %2d),base %2d, best %2d", iVariant+1, nvar, base_line_res[iVariant],iVariantBest+1) ;
    ui->label_Variant->setText(Abuff);

    FillVariantLinesDisplay( iVariant ) ;
}

void MainWindow::on_tableViewCombDiffLines_viewportEntered()
{
    int i ;

    i = 0 ;
}

void MainWindow::on_tableViewCombDiffLines_doubleClicked(QModelIndex index)
{
    int i = index.row() ;

    //int iNlinesView_Tmp  = 1 ;
    //if( iShowMode == 2 ) iNlinesView_Tmp = iSingleLinesViewNumber ;

    if( iShowMode == 1 )
        if(diffdat[iVariant][i]==-1) return ;

    if(  ii2[i] != 1 ) ii2[i] = 1 ;
    else
         ii2[i] = -1 ;

    if(  ii2[i] == 1 )
    {
        table_model->item(index.row(),index.column())->setCheckState(Qt::Checked) ;
        table_model->item(index.row(),index.column())->setForeground(Qt::red);
    }
    else
    {
        table_model->item(index.row(),index.column())->setCheckState(Qt::Unchecked) ;
        table_model->item(index.row(),index.column())->setForeground(Qt::white);
    }
}

void MainWindow::on_tableViewCombDiffLines_pressed(QModelIndex index)
{

}

void MainWindow::on_tableViewCombDiffLines_activated(QModelIndex index)
{

}

void MainWindow::on_tableViewCombDiffLines_entered(QModelIndex index)
{

}

void MainWindow::on_tableViewCombDiffLines_customContextMenuRequested(QPoint pos)
{

}




void MainWindow::TimerProcessingSlot()
{
    int line_num, ichange = 0 ;
    void EstimateEnergy() ;

    iTimerCount++ ;

    if( iUpdateMainHeader > 0 )
    {
        iUpdateMainHeader-- ;
        if( iUpdateMainHeader == 0 )
        {
            ui->lineEdit_VState->setText( VibStateNames[WorkSpace.Iv-1] ) ;

            ReadBankLevel( WorkSpace.Iv-1,WorkSpace.iCurrentRotationState) ;
            ui->lineEdit_DataBankEnergy->setText( cBaseEnergyInfo ) ;
        }
    }

    if( table_model == NULL ) return ;

    int iNlinesView_Tmp  = 1 ;
    if( iShowMode == 2 ) iNlinesView_Tmp = iSingleLinesViewNumber ;

    for(line_num = 0 ;  line_num < (ncd*iNlinesView_Tmp) ; line_num++)
    {
        if( table_model->item(line_num,0)->checkState() == Qt::Checked )
        {
            if(  ii2[line_num] != 1 )
            {
                ii2[line_num] = 1 ;
                table_model->item(line_num,0)->setForeground(Qt::red);
                ichange = 1 ;
            }
        }
        else
        {
            if(  ii2[line_num] == 1 )
            {
                ii2[line_num] = -1 ;
                table_model->item(line_num,0)->setForeground(Qt::white);
                ichange = 1 ;
            }

        }
    }
    QScrollBar *v_scrolbar = ui->tableView_Assignment->verticalScrollBar() ;
    v_scrolbar->setValue(ui->tableViewCombDiffLines->verticalScrollBar()->value());

    if( ichange == 1 )
    {
        if( iShowMode == 1 )
            EstimateEnergy() ;
        else
            Abuff[0] = 0x0 ;
        ui->lineEdit_EstimatedEnergy->setText(Abuff);
    }
}





int AskOverwrite(char *str)
{
    int i ;

    i = QMessageBox::question( NULL, QString("Question"), QString(str),
                                  QMessageBox::Yes|QMessageBox::YesToAll|QMessageBox::No ) ;

    switch(i)
    {
    case QMessageBox::Yes :
        return 1 ;
    case QMessageBox::YesToAll :
        return 2 ;
    case QMessageBox::No :
        return -1 ;
    default :  return -1 ;
    }
}



#include "dialog_selectfield.h"


int SelectField(char *buffer)
{
    Dialog_SelectField Dialod_Field ;

    Dialod_Field.setMessageText( buffer) ;
    Dialod_Field.setModal(true);
    Dialod_Field.exec() ;
    return Dialod_Field.iRet ;
}


void MainWindow::on_actionWriteAssignment_1_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;

    InitLinesAssignmentBankForModify() ;
    iTimerCount = 0 ;
    //while(iTimerCount<2) ;

    if( iShowMode == 1 ) //  work with variants
    {
        WriteAssignmentToBase( 0 ) ;
        FillVariantLinesDisplay( iVariant ) ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void Write_Ident(int line_diff, int line_spec, int j, int n_mark) ;
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;
        iOverwriteAllFlag = 0 ;
        Write_Ident( nl, ii, 0, i ) ;

        if((iBestSingleLine != i)&&(iBestSingleLine >= 0) )
        {
            ii2[iBestSingleLine] = -1 ;
            teach2( P_x, P_mu_s[0], iBestSingleLine, ii2, iSingleLinesViewNumber);
            ii2[iBestSingleLine] = 1 ;
        }

        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
            teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
    }
    InitLinesAssignmentBankForReadOnly() ;
}

void MainWindow::on_actionWriteAssignment_2_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;

    InitLinesAssignmentBankForModify() ;
    iTimerCount = 0 ;
    //while(iTimerCount<2) ;

    if( iShowMode == 1 ) //  work with variants
    {
        WriteAssignmentToBase( 1 ) ;
        FillVariantLinesDisplay( iVariant ) ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void Write_Ident(int line_diff, int line_spec, int j, int n_mark) ;
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        Write_Ident( nl, ii, 1, i ) ;
        if((iBestSingleLine != i)&&(iBestSingleLine >= 0) )
        {
            ii2[iBestSingleLine] = -1 ;
            teach2( P_x, P_mu_s[0], iBestSingleLine, ii2, iSingleLinesViewNumber);
            ii2[iBestSingleLine] = 1 ;
        }

        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
            teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);

        FillCombinationSingleLinesDisplay(0) ;
    }

    InitLinesAssignmentBankForReadOnly() ;
}

void MainWindow::on_actionWriteAssignment_3_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;

    InitLinesAssignmentBankForModify() ;
    iTimerCount = 0 ;
    //while(iTimerCount<2) ;

    if( iShowMode == 1 ) //  work with variants
    {
        WriteAssignmentToBase( 2 ) ;
        FillVariantLinesDisplay( iVariant ) ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void Write_Ident(int line_diff, int line_spec, int j, int n_mark) ;
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        Write_Ident( nl, ii, 2, i ) ;
        if((iBestSingleLine != i)&&(iBestSingleLine >= 0) )
        {
            ii2[iBestSingleLine] = -1 ;
            teach2( P_x, P_mu_s[0], iBestSingleLine, ii2, iSingleLinesViewNumber);
            ii2[iBestSingleLine] = 1 ;
        }

        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
            teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
    }

    InitLinesAssignmentBankForReadOnly() ;
}







void MainWindow::on_actionDelete_assignment_1_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;
    void Del_Ident(int i4, int j) ;

    if( iShowMode == 1 ) //  work with variants
    {
        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        if( (i<0) || (i>=ncd) )  return ;

        int i4 = diffdat[iVariant][i] ;

        if(i4==-1) return ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( i4, 0 ) ;
        FillVariantLinesDisplay( iVariant ) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( ii, 0 ) ;
        //Write_Ident( nl, ii, 2, i ) ;
        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
        //    teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
}

void MainWindow::on_actionDelete_assignment_2_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;
    void Del_Ident(int i4, int j) ;

    if( iShowMode == 1 ) //  work with variants
    {
        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        if( (i<0) || (i>=ncd) )  return ;

        int i4 = diffdat[iVariant][i] ;

        if(i4==-1) return ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( i4, 1 ) ;
        FillVariantLinesDisplay( iVariant ) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( ii, 1 ) ;
        //Write_Ident( nl, ii, 2, i ) ;
        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
        //    teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
}

void MainWindow::on_actionDelete_assignment_3_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;
    void Del_Ident(int i4, int j) ;

    if( iShowMode == 1 ) //  work with variants
    {
        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        if( (i<0) || (i>=ncd) )  return ;

        int i4 = diffdat[iVariant][i] ;

        if(i4==-1) return ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( i4, 2 ) ;
        FillVariantLinesDisplay( iVariant ) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( ii, 2 ) ;
        //Write_Ident( nl, ii, 2, i ) ;
        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
        //    teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
}

void MainWindow::on_actionSave_energy_triggered()
{
    void save_variant_level() ;
    void save_level_single_line( int i, int iSingleLinesViewNumber ) ;
    int InitEnergyBankForModify() ;
    int InitEnergyBankForReadOnly() ;

    InitEnergyBankForModify() ;

    if( iShowMode == 1 )
    {
        save_variant_level() ;
        ReadBankLevel( WorkSpace.Iv-1,WorkSpace.iCurrentRotationState) ;
        ui->lineEdit_DataBankEnergy->setText( cBaseEnergyInfo ) ;

    }
    else
        if( iShowMode == 2 )  // single lines view
    {
        int i = ui->tableViewCombDiffLines->currentIndex().row() ;

        save_level_single_line( i, iSingleLinesViewNumber ) ;

        ReadBankLevel( WorkSpace.Iv-1,WorkSpace.iCurrentRotationState) ;
        ui->lineEdit_DataBankEnergy->setText( cBaseEnergyInfo ) ;
    }

    InitEnergyBankForReadOnly() ;
}

void MainWindow::on_actionClear_energy_triggered()
{
    void clear_lev() ;
    int InitEnergyBankForModify() ;
    int InitEnergyBankForReadOnly() ;

    InitEnergyBankForModify() ;

    clear_lev() ;
    Abuff[0] = 0x0 ;
    ui->lineEdit_DataBankEnergy->setText(Abuff) ;

    ReadBankLevel( WorkSpace.Iv-1,WorkSpace.iCurrentRotationState) ;
    ui->lineEdit_DataBankEnergy->setText( cBaseEnergyInfo ) ;

    InitEnergyBankForReadOnly() ;
}






void MainWindow::on_toolButton_SearchSingleLines_clicked()
{
    int search_lines(int search_mode, double E ) ;
    int  PredictionFileProcessing( char *RotationStateName) ;
    int calc() ;

    //strcpy( UpperRotationStateName,ui->lineEdit_RState->text().toAscii().data()) ;
    //ui->tableViewCombDiffLines->setEnabled(true);
    //ui->tableView_Assignment->setEnabled(true);
    iTablesAreCleared = 0 ;

    iShowMode = 2 ;

    iSingleLinesViewNumber = (WorkSpace.iSingleLinesViewNumber * 2) + 1 ;

    if( WorkSpace.iUsePrediction == 1 )
    {
        PredictionFileProcessing( ui->lineEdit_RState->text().toAscii().data() ) ;
    }
    else
    {
        calc() ;
    }

    search_lines(0, 0.0) ;

    sprintf(Abuff,"%.6f", ecu) ;
    ui->lineEdit_ModelEnergy->setText(Abuff);

    ui->action_PgUp->setEnabled(false) ;
    ui->action_PgDn->setEnabled(false) ;
    ui->pushButton_NextCombDiffVariant->setEnabled(false);
    ui->pushButton_PrevCombDiffVariant->setEnabled(false);

    if( ncd>0 )
    {

        EnableDatabaseButtons(true) ;

        //i3=ChooseVar();   /*nline=0;*/
        sprintf(Abuff,"Combination %d, view %d around", ncd, iSingleLinesViewNumber ) ;
        ui->label_Variant->setText(Abuff);

        if( table_model ) delete table_model ;
        table_model = new QStandardItemModel(ncd,1) ;
        ui->tableViewCombDiffLines->setModel( table_model );
        ui->tableViewCombDiffLines->setColumnWidth(0,ui->tableViewCombDiffLines->width()) ;

        if( table_model_assignment ) delete table_model_assignment ;
        table_model_assignment = new QStandardItemModel(ncd,DEF_ASSIGNMENT_FIELDS_NUMBER) ;
        ui->tableView_Assignment->setModel( table_model_assignment ) ;
        //ui->tableView_Assignment->setSelectionMode(QAbstractItemView::NoSelection);
        ui->tableView_Assignment->setColumnWidth(0,ui->tableView_Assignment->width()/2) ;
        ui->tableView_Assignment->setColumnWidth(1,ui->tableView_Assignment->width()/2) ;
        ui->tableView_Assignment->setColumnWidth(2,ui->tableView_Assignment->width()/2) ;
        ui->tableView_Assignment->setColumnWidth(3,ui->tableView_Assignment->width()/2) ;
        ui->tableView_Assignment->setColumnWidth(4,ui->tableView_Assignment->width()/2) ;

        int line_num ;
        for(line_num = 0 ; line_num<ncd * iSingleLinesViewNumber ; line_num++)
        {
            table_item[0] = new QStandardItem() ;
            table_item[0]->setEditable(false) ;
            table_item[1] = new QStandardItem() ;
            table_item[1]->setEditable(false) ;
            table_item[2] = new QStandardItem() ;
            table_item[2]->setEditable(false) ;
            table_item[3] = new QStandardItem() ;
            table_item[3]->setEditable(false) ;
            table_item[4] = new QStandardItem() ;
            table_item[4]->setEditable(false) ;
            table_item[5] = new QStandardItem() ;
            table_item[4]->setEditable(false) ;
            //table_item[0]->setCheckable(true) ;

            table_model->setItem( line_num, 0, table_item[0] ) ;

            table_model_assignment->setItem( line_num, 0, table_item[1] ) ;
            table_model_assignment->setItem( line_num, 1, table_item[2] ) ;
            table_model_assignment->setItem( line_num, 2, table_item[3] ) ;
            table_model_assignment->setItem( line_num, 3, table_item[4] ) ;
            table_model_assignment->setItem( line_num, 4, table_item[5] ) ;
        }
    }
    else
        EnableDatabaseButtons(false) ;

    FillCombinationSingleLinesDisplay(1) ;

}



void MainWindow::FillCombinationSingleLinesDisplay(int iRecognitionFlag)
{
    int line_num, ispec_line ;
    void showSinglline(int icombline,int ispecline, char *Abuff) ;
    int shvarline(int line_num,int variant) ;
    void shApline(int iline,int icomb_index) ;
    void MarkCombinationRecognition(int ivar) ;
    void EstimateEnergy() ;
    double ConfS( Pvector P_x, Pvector P_mu, int Ij, int iNSingleView) ;
    int number(double nu,float dnu,int *f) ;
    void Average_Scalc() ;

    //ui->tableWidgetCombDiffLines->setRowCount(ncd) ;
    //ui->tableWidgetCombDiffLines->setColumnCount(1) ;

    //MarkCombinationRecognition(iVariant) ;

    int k=0,  found, ii ;

    if( iRecognitionFlag == 1 )
    {
        iBestSingleLine = -1 ;
        dBestSingleLine = -1.0 ;
    }

    Average_Scalc() ;

    for(line_num = 0 ;  line_num<ncd ; line_num++)
    {

        int i = number(nucalc[line_num],2.5,&found);

        for( ispec_line=i-(iSingleLinesViewNumber-1)/2 ; ispec_line<=( i + (iSingleLinesViewNumber-1)/2 ); ispec_line++)
        {

            ii=i+k-(k/iSingleLinesViewNumber)*iSingleLinesViewNumber - (iSingleLinesViewNumber-1)/2;


            double dRecog = ConfS( P_x , P_mu_s[0], k, iSingleLinesViewNumber ) ;
            if( iRecognitionFlag == 1 )
            {
                if(  dRecog > 0.0 )
                {
                    ii2[k] = 1 ;
                    if( dBestSingleLine < dRecog )
                    {
                        dBestSingleLine = dRecog ;
                        iBestSingleLine = k ;
                    }
                }
            }
            else  ii2[k] = -1 ;

            showSinglline(line_num, ispec_line, Abuff) ;
            table_model->item(k,0)->setText(Abuff) ;

            shApline( ispec_line, line_num) ;
            table_model_assignment->item(k,0)->setText(cDisplayLinesAssignmentFields[0]) ;
            table_model_assignment->item(k,1)->setText(cDisplayLinesAssignmentFields[1]) ;
            table_model_assignment->item(k,2)->setText(cDisplayLinesAssignmentFields[2]) ;
            table_model_assignment->item(k,3)->setText(cDisplayLinesAssignmentFields[3]) ;
            table_model_assignment->item(k,4)->setText(cDisplayLinesAssignmentFields[4]) ;

            table_model->item(k,0)->setCheckable(true);

            if( iRecognitionFlag == 1 )
            {
                if(  ii2[k] == 1 )
                {
                    table_model->item(k,0)->setCheckState(Qt::Checked) ;
                    table_model->item(k,0)->setForeground(Qt::red);
                }
                else
                {
                    table_model->item(k,0)->setCheckState(Qt::Unchecked) ;
                    table_model->item(k,0)->setForeground(Qt::white);
                }
            }
            k++ ;
        }
    }

    if( iRecognitionFlag == 1 )
        if( iBestSingleLine >= 0 )
            ui->tableViewCombDiffLines->selectRow(iBestSingleLine) ;

    //EstimateEnergy() ;
    Abuff[0] = 0x0 ;
    ui->lineEdit_EstimatedEnergy->setText(Abuff);

}

void MainWindow::on_pushButton_PrevCombDiffVariant_clicked()
{
    if( iVariant>0 ) iVariant-- ;

    sprintf(Abuff,"Var.%2d (from %2d),base %2d, best %2d", iVariant+1, nvar, base_line_res[iVariant],iVariantBest+1) ;
    ui->label_Variant->setText(Abuff);

    FillVariantLinesDisplay( iVariant ) ;
}

void MainWindow::on_pushButton_NextCombDiffVariant_clicked()
{
    if( iVariant<nvar-1 ) iVariant++ ;

    sprintf(Abuff,"Var.%2d (from %2d),base %2d, best %2d", iVariant+1, nvar, base_line_res[iVariant],iVariantBest+1) ;
    ui->label_Variant->setText(Abuff);

    FillVariantLinesDisplay( iVariant ) ;
}

void MainWindow::on_action_PgUp_triggered()
{
    if( iVariant>0 ) iVariant-- ;

    sprintf(Abuff,"Var.%2d (from %2d),base %2d, best %2d", iVariant+1, nvar, base_line_res[iVariant],iVariantBest+1) ;
    ui->label_Variant->setText(Abuff);

    FillVariantLinesDisplay( iVariant ) ;
}

void MainWindow::on_action_PgDn_triggered()
{
    if( iVariant<nvar-1 ) iVariant++ ;

    sprintf(Abuff,"Var.%2d (from %2d),base %2d, best %2d", iVariant+1, nvar, base_line_res[iVariant],iVariantBest+1) ;
    ui->label_Variant->setText(Abuff);

    FillVariantLinesDisplay( iVariant ) ;
}

void MainWindow::on_action_Teach_triggered()
{
    void teach1( Pvector P_x, Pvector P_mu, int line_num,int variant,int *classification);

    if( iShowMode == 1 ) //  work with variants
    {
        int i1, i4 ;
        for(i1=0;i1<ncd;i1++)
        {
           i4=diffdat[iVariant][i1] ;
           if( (i4>=0)&&(ii2[i1]>0) )
               teach1( P_x, P_mu[0], i1, iVariant,ii2);
        }

        FillVariantLinesDisplay( iVariant ) ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        for(i=0;i< ncd * iSingleLinesViewNumber; i++)
            teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(1) ;
    }
}

void MainWindow::on_actionAbout_triggered()
{
    this->DialogAbout.show() ;
}

void MainWindow::on_actionLevelsDataView_triggered()
{
    char cReportName[256] ;
    int ReadLevelName(FILE *fp,int Number,LevelsHead_type lhead, VIBRATION_STATE_NAME_TYPE RotStateName);
    int ReadLevel(FILE *fp,int Number,Level_type *buffer, LevelsHead_type level, int Band);

    CloseAllFiles() ;

    strcpy( cReportName, WorkSpace.name[DEF_UPPER_STATE_BASE_INDEX] ) ;
    int l = strlen(cReportName) ;
    int i = l-1 ;
    while( (i>0) && (cReportName[i]!='.') ) i-- ;

    if(i>0)  cReportName[i] = 0x0 ;

    strcat( cReportName,".txt") ;

    FILE *fp_base = fopen(WorkSpace.name[DEF_UPPER_STATE_BASE_INDEX], "rb") ;
    if( fp_base == NULL ) return ;


    lhead.EndPosition = 0 ;
    fread(&lhead,sizeof(lhead),1,fp_base);
    //fread(VibStateNames,sizeof(VIBRATION_STATE_NAME_TYPE)*lhead.Nbands,1,fp_base);


    FILE *fp_result = fopen(cReportName, "wt") ;


    int iV ;

    fread(VibStateNames,sizeof(VIBRATION_STATE_NAME_TYPE)*lhead.Nbands,1,fp_base);
    for(iV = 0; iV<lhead.Nbands ; iV++)
    {
        fprintf(fp_result,"Vib.state   %s\n", VibStateNames[iV] ) ;
        fprintf(fp_result,"        State                Energy     Nlines        RMS       Note\n" ) ;
        i=0;
        //lhead.NRotationStates;

        do{
            //ReadLevelName(fp_base,i, Abuff);
            if( ReadLevelName(fp_base,i, lhead, Abuff) )
            {
                if(Abuff[strlen(Abuff)-1]==0xa) Abuff[strlen(Abuff)-1] = 0x0 ;
                if(Abuff[strlen(Abuff)-1]==0xd) Abuff[strlen(Abuff)-1] = 0x0 ;
                if(Abuff[strlen(Abuff)-1]==0xa) Abuff[strlen(Abuff)-1] = 0x0 ;
                fprintf(fp_result, "%15s   ", Abuff ) ;
                int k = ReadLevel(fp_base, i, &level, lhead, iV ) ;
                if( k )
                    fprintf(fp_result," %17.6f    %2d  %15.6f   %s\n", level.Energy,level.Nlines,level.RMS, level.Note ) ;
            }
            i++ ;
        }while(feof(fp_base)==0) ;

        fprintf(fp_result, "\n") ;
    }

    fclose(fp_result) ;
    fclose(fp_base) ;

    InitAllWorkDataFiles() ;

    void CallEditText( char *cReportName) ;

    CallEditText( cReportName ) ;
}


void MainWindow::on_action_LinesDataView_triggered()
{
#define MAX_V   200

    char Vnames[MAX_V][50];


    LinesHead_type shead;
    Line_type sline;
    long *positios,CatPosition,pp;
    unsigned SpecSize,LevSize,Size;
    char mode,mode1;
    int j,S,N,Nn[MAX_V],found,k,v, numb,numb1;
    double ff,minfr[MAX_V],maxfr[MAX_V],dTmp;
    double stren[MAX_V],maxint[MAX_V],minint[MAX_V],fTmp,stsum,gt,gt1,br;
    int nva,nvb,nv,nv1,nv2;

    char cReportName[256],  cMainStringBuffer[128] ;
    int ReadLine(FILE *fp,int Number,Line_type *buffer);
    int WriteLine(FILE *fp,int Number,Line_type *buffer);


    CloseAllFiles() ;

    strcpy( cReportName, WorkSpace.name[DEF_LINES_ASSIGN_BASE_INDEX] ) ;
    int l = strlen(cReportName) ;
    int i = l-1 ;
    while( (i>0) && (cReportName[i]!='.') ) i-- ;

    if(i>0)  cReportName[i] = 0x0 ;

    strcat( cReportName,".txt") ;

    FILE *fp_base = fopen(WorkSpace.name[DEF_LINES_ASSIGN_BASE_INDEX], "rb") ;
    if( fp_base == NULL ) return ;


    lhead.EndPosition = 0 ;
    fread(&lhead,sizeof(lhead),1,fp_base);
    //fread(VibStateNames,sizeof(VIBRATION_STATE_NAME_TYPE)*lhead.Nbands,1,fp_base);


    FILE *fp_result = fopen(cReportName, "wt") ;


    fseek(fp_base,0,SEEK_SET);
    fread(&shead,sizeof(shead),1,fp_base);



    double  abko1, pressure, dFreqBegin, dFreqEnd, alfad ;

    if (  ReadLine(fp_base,              0,&sline) != -1 ) dFreqBegin = sline.Frequansy;
    if (  ReadLine(fp_base, shead.Number-1,&sline) != -1 ) dFreqEnd = sline.Frequansy;

    switch(WorkSpace.iatr)
    {
    case  MEASUREMENTS_TYPE_ABSORBTION:
                         pressure=WorkSpace.dPressure/760;
                         alfad=sqrt(WorkSpace.dTemperature/WorkSpace.dAlphaD);
                         alfad=(3.58E-7)*(dFreqBegin+dFreqEnd)*0.5*alfad;
                         abko1=log(2.0)/3.141592;
                         abko1=sqrt(abko1)/alfad;
                         break;
    case  MEASUREMENTS_TYPE_TRANSMITTANCE:
                        pressure=WorkSpace.dPressure/760;
                        alfad=sqrt(WorkSpace.dTemperature/WorkSpace.dAlphaD);
                        alfad=(3.58E-7)*(dFreqBegin+dFreqEnd)*0.5*alfad;
                        abko1=log(2.0)/3.141592;
                        abko1=sqrt(abko1)/alfad;
    default : ;
    };


    for(i=0;i<MAX_V;i++)
    {
        Nn[i]=0; stren[i]=0;
        maxint[i]=0;  minint[i]=10000;
        maxfr[i]=0;   minfr[i]=100000;
    }

    nv1=0;
    double maxS_n=0.0 , maxF_n;
    double summS_n=0.0, summS=0.0;
    int nlinsp_n=0;


    for(i=0; i < shead.Number ;i++ )
    {
       if (  ReadLine(fp_base,i,&sline) != -1 )
        //if(  sline.Intensity >0  )
       {
             sprintf(cMainStringBuffer,"\n%15.4f%15.2E%10.4f  ",
                        sline.Frequansy,sline.Intensity,sline.MissError);

             fTmp=fabs( sline.Intensity );

             double abko ;
             switch(WorkSpace.iatr)
             {
             case  MEASUREMENTS_TYPE_ABSORBTION:
                    fTmp=1-fTmp;
                    abko=fTmp;
                    abko=-log(abko)/abko1/pressure/WorkSpace.dPathLen;
                    fTmp=abko;
                  break;
             case  MEASUREMENTS_TYPE_TRANSMITTANCE:
                 abko=fTmp;
                 if(fTmp==0)
                 {
                     printf(" ERROR TRANSMITANCE   %d,   %.4f  %.4f", i, sline.Frequansy, fTmp);
                 }
                 abko=-log(abko)/abko1/pressure/WorkSpace.dPathLen;
                 fTmp=abko;
             };

             if( fTmp<0.0 ) fTmp=-fTmp;

             sprintf(&cMainStringBuffer[strlen(cMainStringBuffer)],"%12.4E   ", fTmp );
             fprintf(fp_result,cMainStringBuffer) ;

             int ispace, len = strlen(cMainStringBuffer) ;
             for(ispace = 0 ; ispace < len ; ispace++ ) cMainStringBuffer[ispace] = ' ' ;
             cMainStringBuffer[ len-1 ] = 0x0 ;



             nv2 = 0 ;
             for( j=0; j<DEF_ASSIGNMENT_FIELDS_NUMBER; j++ )
              if( sline.V_upper[j][0] != 0 ) nv2++ ;
             if( nv2 == 0 )
             {
                if( maxS_n < fTmp )
                {
                    maxS_n = fTmp ;  maxF_n = sline.Frequansy ;
                }
                    nlinsp_n++ ;
                    summS_n = summS_n + fTmp ;
              }
              else summS = summS + fTmp ;


             for( j=0; j<DEF_ASSIGNMENT_FIELDS_NUMBER; j++ )
             if( sline.V_upper[j][0] != 0 )
             {
                 if(sline.upper_state[j][strlen(sline.upper_state[j])-1]==0xd) sline.upper_state[j][strlen(sline.upper_state[j])-1] = 0x0 ;
                 if(sline.upper_state[j][strlen(sline.upper_state[j])-1]==0xa) sline.upper_state[j][strlen(sline.upper_state[j])-1] = 0x0 ;
                 if(sline.upper_state[j][strlen(sline.upper_state[j])-1]==0xd) sline.upper_state[j][strlen(sline.upper_state[j])-1] = 0x0 ;

                 if(sline.ground_state[j][strlen(sline.ground_state[j])-1]==0xd) sline.ground_state[j][strlen(sline.ground_state[j])-1] = 0x0 ;
                 if(sline.ground_state[j][strlen(sline.ground_state[j])-1]==0xa) sline.ground_state[j][strlen(sline.ground_state[j])-1] = 0x0 ;
                 if(sline.ground_state[j][strlen(sline.ground_state[j])-1]==0xd) sline.ground_state[j][strlen(sline.ground_state[j])-1] = 0x0 ;

               if(j>0)
               {
                   fprintf(fp_result,"\n");
                   fprintf(fp_result,cMainStringBuffer) ;
               }
               fprintf(fp_result,"%8s ", sline.Note[j]);
               sscanf(sline.V_upper[j],"%s",Abuff);
               fprintf(fp_result,"%15s",Abuff);
               fprintf(fp_result,"   %s  ",sline.upper_state[j]);
               fprintf(fp_result," %s  ",sline.ground_state[j]);
               fprintf(fp_result,"  %10s ;",sline.V_ground[j]);


               found=0; v=0; k=0;
               sscanf(sline.V_upper[j],"%s",Abuff);
               for(k=0;k<nv1;k++)
               {  //printf(" %s ",Vnames[k]);
                  if( strcmp(Abuff,Vnames[k])==0 )
                             { Nn [k]++ ; found=1;  v=k; }
               }
               if( found==0 )
               {
                  strcpy(Vnames[nv1],Abuff); Nn [nv1]++ ; nv1++;
                  printf("Vib.State %d   name=%s\n", nv1,Abuff);
               }

               dTmp=sline.Frequansy;
               if(dTmp<minfr[v]) minfr[v] =dTmp ;
               if(dTmp>maxfr[v]) maxfr[v] =dTmp ;

               //fTmp= fabs( intensity(sline.Intensity) );
               if(fTmp<minint[v]) minint[v] =fTmp ;
               if(fTmp>maxint[v]) maxint[v] =fTmp ;

               fTmp=fTmp/nv2;
               stren[v]= stren[v] + fTmp ;


            }
         }
     }


    fprintf(fp_result,"\n\nLines number:                  %5d", shead.Number);
    fprintf(fp_result,"\nNot assigned lines:  %5d    %d%%",nlinsp_n,  (long int)(nlinsp_n)*100/shead.Number);
    fprintf(fp_result,"\nNot assigned line with\n maximal absorbtion:  Nu: %12.4f   Int: %10.4e",maxF_n,maxS_n);
    fprintf(fp_result,"\nNot assigned lines absorbtion:  %10.4e",summS_n);
    fprintf(fp_result,"\nThe spectrum common absorbtion:  %10.4e",summS);


    fprintf(fp_result,"\n\n");
    fprintf(fp_result,"\n      V.      N.lines      Integr.int.      min.fr       max.fr.      min.int.     max.int.");
    fprintf(fp_result,"\n--------------------------------------------------------------------------------------------");
    for(i=0;i<MAX_V;i++)
    {
        if(Nn[i]==0)
        {
            minint[i]=0; minfr[i]=0;
        }
        else
            fprintf(fp_result,"\n%15s   %3d %12.5f %13.4f %13.4f %13.4E %13.4E",
                Vnames[i],Nn[i],stren[i],minfr[i],maxfr[i],minint[i],maxint[i]);
    }
    fprintf(fp_result,"\n--------------------------------------------------------------------------------------------");


    fclose(fp_result) ;
    fclose(fp_base) ;

    InitAllWorkDataFiles() ;

    void CallEditText( char *cReportName) ;

    CallEditText( cReportName ) ;
}




void MainWindow::on_action_RemoveAllAssignmentForLevel_triggered()
{
    int i,j,change;
    int ReadLine(FILE *fp,int Number,Line_type *buffer);
    int WriteLine(FILE *fp,int Number,Line_type *buffer);
    int InitLinesAssignmentBankForModify() ;
    int InitLinesAssignmentBankForReadOnly() ;


    InitLinesAssignmentBankForModify() ;

    for(i=0;i<nlinsp;i++)
    {
        change=0;
        if( ReadLine(fp_LinesBank,i,&sline) != -1)
           for(j=0;j<3;j++)
             if(     (strcmp(VibStateNames[WorkSpace.Iv-1],sline.V_upper[j])==0)&&
                     (strcmp(sline.upper_state[j],UpperRotationStateName)==0) )
        {
            sline.V_upper[j][0]=0x0;  change=1;
        }

        for(j=0;j<2;j++)
         if((sline.V_upper[j][0]==0x0)&&(sline.V_upper[j+1][0]!=0x0))
        {
            strcpy( sline.upper_state[j],sline.upper_state[j+1]);
            strcpy( sline.ground_state[j],sline.ground_state[j+1]);
            strcpy( sline.Note[j],sline.Note[j+1]);
            strcpy( sline.V_ground[j],sline.V_ground[j+1]);
            strcpy( sline.V_upper[j],sline.V_upper[j+1]);
            sline.upper_state[j+1][0]=0;
            sline.V_upper[j+1][0]=0;
            change=1;
        }
        if(change==1)
           if(  WriteLine(fp_LinesBank,i,&sline) == -1) printf(" Write Error ");
   }

   InitLinesAssignmentBankForReadOnly() ;

   if( iShowMode == 1 )
        FillVariantLinesDisplay(iVariant);
   else if( iShowMode == 2 )
        FillCombinationSingleLinesDisplay(0);

}

void MainWindow::on_action_Save_config_triggered()
{
    QString Filters = QString("Workspace *.wsp (*.wsp)") ;
    QString FilterRet ;
    void SaveWorkSpace(const char *name) ;

    QFileDialog myFileDialog(this, tr("Save File"),
                             QString()) ;

    if( !fileNamePath.isEmpty() )
    {
        myFileDialog.setDirectory(QDir(fileNamePath));
    }


    QString fileName = myFileDialog.getSaveFileName (this, tr("Open File"), QString(""), Filters, &FilterRet, 0  ) ;

    if( !fileName.isEmpty() )
    {
        fileNamePath = fileName.left(fileName.lastIndexOf('/') ) ;

        qstringCurrentFileName = fileName ;
        SaveWorkSpace(fileName.toAscii().constData()) ;
        //this->setWindowTitle( QString("Atmel ARM programmer -  ")+fileName.section(QChar('/'),-1,-1) );
    }
}

void MainWindow::on_action_WriteAssignment_Y_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;

    InitLinesAssignmentBankForModify() ;
    iTimerCount = 0 ;
    //while(iTimerCount<2) ;

    if( iShowMode == 1 ) //  work with variants
    {
        WriteAssignmentToBase( -1 ) ;
        FillVariantLinesDisplay( iVariant ) ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void Write_Ident(int line_diff, int line_spec, int j, int n_mark) ;
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;
        iOverwriteAllFlag = 0 ;
        Write_Ident( nl, ii, -1, i ) ;

        if((iBestSingleLine != i)&&(iBestSingleLine >= 0) )
        {
            ii2[iBestSingleLine] = -1 ;
            teach2( P_x, P_mu_s[0], iBestSingleLine, ii2, iSingleLinesViewNumber);
            ii2[iBestSingleLine] = 1 ;
        }

        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
            teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
    }
    InitLinesAssignmentBankForReadOnly() ;

}

void MainWindow::on_actionWriteAssignment_4_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;

    InitLinesAssignmentBankForModify() ;
    iTimerCount = 0 ;
    //while(iTimerCount<2) ;

    if( iShowMode == 1 ) //  work with variants
    {
        WriteAssignmentToBase( 3 ) ;
        FillVariantLinesDisplay( iVariant ) ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void Write_Ident(int line_diff, int line_spec, int j, int n_mark) ;
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        Write_Ident( nl, ii, 3, i ) ;
        if((iBestSingleLine != i)&&(iBestSingleLine >= 0) )
        {
            ii2[iBestSingleLine] = -1 ;
            teach2( P_x, P_mu_s[0], iBestSingleLine, ii2, iSingleLinesViewNumber);
            ii2[iBestSingleLine] = 1 ;
        }

        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
            teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
    }

    InitLinesAssignmentBankForReadOnly() ;

}

void MainWindow::on_actionWriteAssignment_5_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;

    InitLinesAssignmentBankForModify() ;
    iTimerCount = 0 ;
    //while(iTimerCount<2) ;

    if( iShowMode == 1 ) //  work with variants
    {
        WriteAssignmentToBase( 4 ) ;
        FillVariantLinesDisplay( iVariant ) ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void Write_Ident(int line_diff, int line_spec, int j, int n_mark) ;
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        Write_Ident( nl, ii, 4, i ) ;
        if((iBestSingleLine != i)&&(iBestSingleLine >= 0) )
        {
            ii2[iBestSingleLine] = -1 ;
            teach2( P_x, P_mu_s[0], iBestSingleLine, ii2, iSingleLinesViewNumber);
            ii2[iBestSingleLine] = 1 ;
        }

        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
            teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
    }

    InitLinesAssignmentBankForReadOnly() ;

}

void MainWindow::on_actionDelete_assignment_4_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;
    void Del_Ident(int i4, int j) ;

    if( iShowMode == 1 ) //  work with variants
    {
        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        if( (i<0) || (i>=ncd) )  return ;

        int i4 = diffdat[iVariant][i] ;

        if(i4==-1) return ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( i4, 3 ) ;
        FillVariantLinesDisplay( iVariant ) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( ii, 3 ) ;
        //Write_Ident( nl, ii, 2, i ) ;
        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
        //    teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
        InitLinesAssignmentBankForReadOnly() ;
    }

}

void MainWindow::on_actionDelete_assignment_5_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;
    void Del_Ident(int i4, int j) ;

    if( iShowMode == 1 ) //  work with variants
    {
        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        if( (i<0) || (i>=ncd) )  return ;

        int i4 = diffdat[iVariant][i] ;

        if(i4==-1) return ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( i4, 4 ) ;
        FillVariantLinesDisplay( iVariant ) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( ii, 4 ) ;
        //Write_Ident( nl, ii, 2, i ) ;
        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
        //    teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
}

void MainWindow::on_actionDelete_assignment_Y_triggered()
{
    void WriteAssignmentToBase( int ifield ) ;
    int InitLinesAssignmentBankForReadOnly() ;
    int InitLinesAssignmentBankForModify() ;
    void Del_Ident(int i4, int j) ;

    int iSelectedLine, iSelectedField ;
    //QModelIndex qselected ;
    iSelectedLine = ui->tableView_Assignment->currentIndex().row() ;
    iSelectedField = ui->tableView_Assignment->currentIndex().column() ;

    if( iSelectedLine == -1 ) return ;
    if( iSelectedField == -1 ) return ;

    if( iShowMode == 1 ) //  work with variants
    {
        int i = iSelectedLine ;
        if( (i<0) || (i>=ncd) )  return ;

        int i4 = diffdat[iVariant][i] ;

        if(i4==-1) return ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( i4, iSelectedField ) ;
        FillVariantLinesDisplay( iVariant ) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
    else if( iShowMode == 2 ) //  work with single lines
    {
        void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber ) ;
        void teach2(  Pvector P_x, Pvector P_mu, int line_num, int *classification, int iNSingleView);

        int i = ui->tableViewCombDiffLines->currentIndex().row() ;
        int nl, ii ;

        get_single_line_indexes( i, &nl, &ii, iSingleLinesViewNumber ) ;

        InitLinesAssignmentBankForModify() ;
        Del_Ident( ii, iSelectedField ) ;
        //Write_Ident( nl, ii, 2, i ) ;
        //for(i=0;i< ncd * iSingleLinesViewNumber; i++)
        //    teach2( P_x, P_mu_s[0], i, ii2, iSingleLinesViewNumber);
        FillCombinationSingleLinesDisplay(0) ;
        InitLinesAssignmentBankForReadOnly() ;
    }
}





void ErrorMessage(char *str)
{
     QMessageBox::critical ( NULL, QString("Attention!"), QString(str) ) ; //, StandardButtons buttons = Ok, StandardButton defaultButton = NoButton )
}


int AskContinue(char *str)
{
    int i ;

    i = QMessageBox::question( NULL, QString("Question"), QString(str),
                                  QMessageBox::Yes|QMessageBox::No|QMessageBox::YesToAll ) ;

    switch(i)
    {
    case QMessageBox::Yes :
        return 1 ;
    case QMessageBox::YesToAll :
        return 2 ;
    case QMessageBox::No :
        return -1 ;
    default :  return -1 ;
    }
}

void MainWindow::on_action_Minimal_lines_number_in_combination_triggered()
{
    QInputDialog InpD;
    bool ok ;
    int iRet ;

    iRet = InpD.getInt(  this, QString("Input value"), QString("Minimal lines number in combination"), WorkSpace.crit, 1, 100, 1, &ok ) ;
    if(ok)
    {
        if(iRet<2) iRet = 2 ;
        WorkSpace.crit = iRet ;
        sprintf(cBuffer, "Minimal lines number in combination :  %d", WorkSpace.crit) ;
        ui->action_Minimal_lines_number_in_combination->setText(cBuffer);
    }
}


void MainWindow::on_action_Manual_triggered()
{
    //this->DialogManual.show() ;
#ifdef PLATFORM_WINDOWS
    //int iTmp1 = spawnlp( P_WAIT, "manualview.bat", "0", NULL ) ;
    //unsigned int ProgramExecute(char* Program_Name) ;
    //execvp("manualview.bat", NULL) ;
    if( !process_Manual )  process_Manual = new QProcess(this) ;
           process_Manual->start("manualview.bat") ;

#endif
#ifdef PLATFORM_LINUX
        /*int i = ("xpdf qSlon.pdf") ;
        if( i!= 0 ) system("ghostview qSlon.pdf") ;
        if( i!= 0 ) system("okular qSlon.pdf") ;*/
    if( !process_Manual )  process_Manual = new QProcess(this) ;
            process_Manual->start("xpdf qSlon.pdf") ;
            if( !process_Manual->waitForStarted() )
                process_Manual->start("okular qSlon.pdf");
            if( !process_Manual->waitForStarted() )
                process_Manual->start("kpdf qSlon.pdf");
            if( !process_Manual->waitForStarted() )
                process_Manual->start("ghostview qSlon.pdf");


#endif

}
