#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QProcess>
#include <QStandardItemModel>
#include <QTimer>

namespace Ui {
    class MainWindow;
}


#include "dialog_parameters.h"
#include "dialog_about.h"
//#include "dialog_manual.h"


class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();


    Dialog_Parameters  DialogParameters ;
    Dialog_About    DialogAbout ;
    //Dialog_Manual    DialogManual ;
    QProcess calc_process ;

    QTimer timer ;

    QStandardItemModel *table_model, *table_model_assignment ;
    void FillVariantLinesDisplay( int iVariant ) ;
    void FillCombinationSingleLinesDisplay(int iRecognitionFlag) ;
    void EnableDatabaseButtons( bool flag ) ;
    void ClearTables() ;
    void ClearVariantLinesDisplay() ;
    int iSingleLinesViewNumber, iTablesAreCleared ;


public slots:
    void initMenuValues() ;
    void TimerProcessingSlot() ;

private:
    Ui::MainWindow *ui;

private slots:
    void on_actionDelete_assignment_Y_triggered();
    void on_actionDelete_assignment_5_triggered();
    void on_actionDelete_assignment_4_triggered();
    void on_actionWriteAssignment_5_triggered();
    void on_actionWriteAssignment_4_triggered();
    void on_action_WriteAssignment_Y_triggered();
    void on_action_Save_config_triggered();
    void on_action_RemoveAllAssignmentForLevel_triggered();
    void on_action_LinesDataView_triggered();
    void on_actionLevelsDataView_triggered();
    void on_actionAbout_triggered();
    void on_action_Teach_triggered();
    void on_action_PgDn_triggered();
    void on_action_PgUp_triggered();
    void on_pushButton_NextCombDiffVariant_clicked();
    void on_pushButton_PrevCombDiffVariant_clicked();
    void on_toolButton_SearchSingleLines_clicked();
    void on_actionClear_energy_triggered();
    void on_actionSave_energy_triggered();
    void on_actionDelete_assignment_3_triggered();
    void on_actionDelete_assignment_2_triggered();
    void on_actionDelete_assignment_1_triggered();
    void on_actionWriteAssignment_3_triggered();
    void on_actionWriteAssignment_2_triggered();
    void on_actionWriteAssignment_1_triggered();
    void on_tableViewCombDiffLines_customContextMenuRequested(QPoint pos);
    void on_tableViewCombDiffLines_entered(QModelIndex index);
    void on_tableViewCombDiffLines_activated(QModelIndex index);
    void on_tableViewCombDiffLines_pressed(QModelIndex index);
    void on_tableViewCombDiffLines_doubleClicked(QModelIndex index);
    void on_tableViewCombDiffLines_viewportEntered();
    void on_toolButton_NextCombDiffVariant_clicked();
    void on_toolButton_PrevCombDiffVariant_clicked();
    void on_toolButton_SearchCombDiff_clicked();
    void on_spinBox_Vib_valueChanged(int );
    void on_pushButton_RMinus_clicked();
    void on_pushButton_RPlus_clicked();
    void on_spinBox_J_valueChanged(int );
    void on_labelVibrartionstate_linkActivated(QString link);
    void on_actionFiles_and_parameters_triggered();
    void on_actionExit_triggered();
    void on_actionBase_line_limit_triggered();
    void on_actionLines_number_of_interval_triggered();
    void on_actionCombination_presision_triggered();
    void on_actionMinimal_intensity_triggered();
    void on_action_Load_config_triggered();
    void on_action_Minimal_lines_number_in_combination_triggered();
    void on_action_Manual_triggered();
};

#endif // MAINWINDOW_H
