/*
               
                         FZGZ.cpp             
                       (Pade-Borel)           
               
*/

#include <math.h>


void fzgz1(double c0,double c1,double c2,int beta,double *ff,double *fz,
               double *gz)
{   int n;
    double z,z2,z3,z4,u,s,sb,t,x,a5,a4,b4,fakt,fakt1,fakt2,fakt3,fakt4;


      if(c2<1.0E-20) goto END;

fakt=1.0;
for(n=1;n<=beta;n++) fakt=fakt*n;
fakt1=fakt*(beta+1);
fakt2=fakt1*(beta+2);
fakt3=fakt2*(beta+3);
fakt4=fakt3*(beta+4);
c0=c0/fakt; c1=c1/fakt1; c2=c2/fakt2;
z=c1/c2;
z2=(z*z);z3=z2*z;z4=z3*z;
if( fabs(z)>50.0 ) {
fz[0]=fakt1+fakt2/z+fakt3/z2+fakt4/z3;
gz[0]=-fakt2/z2-2*fakt3/z3-3*fakt4/z4;
                  } else {
         u=0.0;
         if( z<0 ) {
             x=-z;
             if( x<1.0 ) {
             a5=-0.57721566+0.99999193*x-0.24991055*(x*x);
             a5=a5+0.05519968*x*(x*x)-0.00976004*(x*x)*(x*x)+0.00107857
             *x*(x)*(x*x)*x;
             u=-exp(x)*(-log(x)+a5);
                          } else {
             a4=0.2677737343+8.6347608925*x+18.059016973*(x*x);
             a4=a4+8.5733287401*(x*x)*x+(x*x)*(x*x);
             b4=3.9584969228+21.0996530827*x+25.6329561486*(x*x);
             b4=b4+9.5733223454*(x*x)*x+(x*x)*(x*x);
                      u=-a4/b4/x; };
                 }; /*z<0*/
        if( z>0.0 ) {
             x=z;
             if( x<15.0 ) {
             u=0.577215665+log(x); t=1.0;
             n=1;
             do{
                                t=t*x/n;
                                u=u+t/n;
                                n++;
                                }while((n<=60)/*&&(t>1.0E-30)*/);
             u=u*exp(-x);
                          } else {
             u=1.0; t=1.0;
             for(n=1;n<=6;n++) {
                               t=t*n/x;
                               u=u+t;
                               };
             u=u/x;
                                  };
                     }; /*z>0*/
       s=0.0;sb=0.0;t=1.0;/*   beta=2;*/
       for(n=1;n<=beta;n++) {
            t=t*n/z;      /*n/z;*/
            s=s+t/n;
            sb=sb+t/n*(beta+2-n);
                           };
            t=1.0;for(n=1;n<=beta+2;n++) t=t*z;
             /* t=z**(beta+2)  */
            fz[0]=-fakt*z+t*(u-s);
            gz[0]=-fakt+t/z*(1+(beta+2-z)*u-sb);
          }; /* fabs(z)<50 */
ff[0]=fakt*c0+c1*fz[0];

END:;
}
