#include <math.h>
#include <stdlib.h>

#include "flcalc54.h"

int jacobi(int n,double a[SVECSIZE][SVECSIZE],double v[SVECSIZE][SVECSIZE],int eigen)
{    double sm,c,s,t,h,tau,theta,tresh, g;
     int p,q,i,j;        int rot;
     double *b,*z,*d;
  if ((b = new double[SVECSIZE])==NULL) exit(3);
  if ((z = new double[SVECSIZE])==NULL) exit(3);
  if ((d = new double[SVECSIZE])==NULL) exit(3);

 if( eigen==1 ) for(p=0;p<n;p++) { /*printf("\n");*/
                                    for(q=0;q<n;q++) {
                                        if( p==q ) v[p][q]=1.0;
                                              else v[p][q]=0.0;
                                                     }
                                   }
 for(p=0;p<n;p++) {
            d[p]=a[p][p];  b[p]=d[p];   z[p]=0;
                   }
 rot=0;
    for(i=1;i<=50;i++) {
         sm=0;
          for(p=0;p<(n-1);p++) for(q=(p+1);q<n;q++) sm=sm+fabs(a[p][q]);
        if(sm==0) goto l104;
        if( i<4 ) tresh=0.2*sm/(n+1)/(n+1); else tresh=0.0;
         for(p=0;p<n-1;p++) for(q=(p+1);q<n;q++) {
                    g=100.0*fabs(a[p][q]);
if(  (i>4) && ((fabs(d[p])+g)==fabs(d[p])) && ((fabs(d[q])+g)==fabs(d[q])) )
a[p][q]=0.0;
 else
          if( fabs(a[p][q])>tresh ) {
               h=d[q]-d[p];
               if( fabs(h)+g==fabs(h) ) t=a[p][q]/h; else {


                              theta=0.5*h/(a[p][q]);
                              t=1.0/(fabs(theta)+sqrt(1.0+(theta*theta)));
                              if( theta<0.0 ) t=-t;

                                                            }
           c=1.0/sqrt(1.0+t*t);
           s=t*c;
           tau=s/(1.0+c);
           h=t*(a[p][q]);
                   z[p]=z[p]-h;
                   z[q]=z[q]+h;
                   d[p]=d[p]-h;
                   d[q]=d[q]+h;
                   a[p][q]=0.0;
      for(j=0;j<=(p-1);j++) {
           g=a[j][p];  h=a[j][q];
//         if(h<1.0e-30) h=0.0; if(g<1.0e-30) g=0;
           a[j][p]=g-s*(h+g*tau);
           a[j][q]=h+s*(g-h*tau);
                           };
    for(j=(p+1);j<=(q-1);j++) {

            g=a[p][j];   h=a[j][q];
//         if(h<1.0e-30) h=0.0; if(g<1.0e-30) g=0;
         a[p][j]=g-s*(h+g*tau);
         a[j][q]=h+s*(g-h*tau);
                           };
    for(j=(q+1);j<n;j++){
         g=a[p][j];  h=a[q][j];
//         if(h<1.0e-30) h=0.0; if(g<1.0e-30) g=0;
         a[p][j]=g-s*(h+g*tau);
         a[q][j]=h+s*(g-h*tau);
                        };
    if( eigen==1 ) for(j=0;j<n;j++) {
           g=v[p][j];  h=v[q][j];
//         if(h<1.0e-30) h=0.0; if(g<1.0e-30) g=0;
           v[p][j]=g-s*(h+g*tau);
           v[q][j]=h+s*(g-h*tau);
                                      };
            rot=rot+1;
         };/*};*/
         };
      for(p=0;p<n;p++) {
            b[p]=b[p]+z[p];  a[p][p]= b[p];
            z[p]=0.0;
                          };
         };
l104:
delete(b);
delete(z);
delete(d);

return rot;
}; /*jacobi*/
